{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG } {$R+,S+ } {$ELSE } {$D-,L-,R-,S- } {$ENDIF }

{$M 32768,0,327680 }  { Grande Pile  cause des nombreuses "String" }

{*************************************************
 *                                               *
 *                   TELIX 1.0                   *
 *                                               *
 *************************************************}


Unit Telix;

Interface

Uses Dos, Crt, StrTools;

Type PString = ^String;

Type VarStr = String[16];

     VarRef = (VR_BOOL,
               VR_CHAR,
               VR_BYTE,
               VR_SHORT,
               VR_WORD,
               VR_INT,
               VR_LONG,
               VR_REAL,
               VR_STR);

Const VR_CARDINAL : SET OF VarRef = [VR_BYTE,VR_SHORT,VR_WORD,VR_INT,VR_LONG];


Type
     PVarRec = ^VarRec;

     VarRec = Record
       Name      : VarStr;
       Tp        : VarRef;
       Next      : PVarRec;
       Str       : PString;   { entit a part ... }
       Case Integer Of
        0 : ( Bl  : Boolean );
        1 : ( Ch  : Char );
        2 : ( Bt  : Byte );
        3 : ( Sh  : ShortInt );
        4 : ( Wr  : Word );
        5 : ( Int : Integer );
        6 : ( Lg  : Longint );
        7 : ( Rl  : Real );
      End;


     FindFunctProc = Function ( Funct : String ) : Word;
     ExecFunctProc = Function ( n : Word; Var v : VarRec ) : Boolean;
     WritelnProc  = Procedure ( s : String );

Var  ExternalFindFunct : FindFunctProc;
     ExternalExecFunct : ExecFunctProc;
     ExternalWriteln   : WritelnProc;


Type ErrorRef = (E_NOERROR,
  E_INSTR, E_SYNTAX, E_VARNAME, E_VAREXIST, E_MEMORY, E_VARUNKNOWN,
  E_TYPE, E_TOOMANYPARAM, E_PAROUV, E_PARFER, E_VIRGULE,
  E_DIVIDE, E_LABELNAME, E_LABELEXIST, E_LABELUNKNOWN, E_THEN, E_FILE,
  E_BREAK, E_BOGUE);

Function  GetErrorStr( Err : ErrorRef ) : String;
Procedure SetError( Err : ErrorRef );

Function  GetInstr : String;
Function  InstrToBool( Instr : String; Var d : Boolean ) : Boolean;
Function  InstrToStr( Instr : String; Var Dest : String ) : Boolean;
Function  InstrToChar( Instr : String; Var d : Char ) : Boolean;
Function  TestVarCardinal( Var v : VarRec; Var Lg : Longint ) : Boolean;
Function  SizeOfVar( Var v : VarRec ) : Word;
Function  CheckVarCardinal( Var v : VarRec; Var Lg : Longint ) : Boolean;
Function  TestVarReal( Var v : VarRec; Var Rl : Real ) : Boolean;
Function  CheckVarReal( Var v : VarRec; Var Rl : Real ) : Boolean;
Function  CheckTransVarCardinal( Var v : VarRec; Var Lg : Longint ) : Boolean;
Function  TestTransVarReal( Var v : VarRec; Var r : Real ) : Boolean;
Function  CheckTransVarReal( Var v : VarRec; Var r : Real ) : Boolean;
Function  InstrToLong( Instr : String; Var d : Longint ) : Boolean;
Function  InstrToByte( Instr : String; Var d : Byte ) : Boolean;
Function  InstrToShort( Instr : String; Var d : ShortInt ) : Boolean;
Function  InstrToWord( Instr : String; Var d : Word ) : Boolean;
Function  InstrToInt( Instr : String; Var d : Integer ) : Boolean;
Function  InstrToReal( Instr : String; Var d : Real ) : Boolean;
Procedure PlaneTp( Var Dest : VarRec );
Function  InstrToVar( Instr : String; Var Dest : VarRec ) : Boolean;
Function  TestParOuv( s : String ) : Boolean;
Function  TestParFer( s : String ) : Boolean;
Function  TestVirgule( s : String ) : Boolean;
Function  TestEoln( s : String ) : Boolean;
Function  CheckParOuv( s : String ) : Boolean;
Function  CheckParFer( s : String ) : Boolean;
Function  CheckVirgule( s : String ) : Boolean;
Function  CheckEoln( s : String ) : Boolean;


Function  TelixInit( Name : String ) : Boolean;
Function  TelixExecute : Boolean;
Function  TelixGetnLine : Word;
Procedure TelixDone;
Procedure TelixEndDetect;

Implementation

Const
     COMP_LESS  =  1;
     COMP_EQUAL =  2;
     COMP_ABOVE =  4;


Type LabelStr = String[16];

     PLabelRec = ^LabelRec;

     LabelRec = Record
       Name      : LabelStr;
       nLine     : Word;
       LinePos   : Longint;
       Next      : PLabelRec;
      End;


     LineStat = Record
       Line     : String;
       nLine    : Word;       { numro ligne en traitement }
       iRead    : Byte;       { niveau de traitement }
       Instr    : String[20]; { parti de l'instruction seulement }
       DebInstr : Byte;
       LinePos  : Longint;    { position sur disque du dbut de la ligne courante }
      End;


     PVarFileRec = ^VarFileRec;

     VarFileRec = Record
       f     : File;
       Next  : PVarFileRec;
      End;


Var Src        : File;

    LnSt       : LineStat;

    EndDetect  : Boolean;    { Instruction d'arrt repere }
    ErrDetect  : Boolean;    { Erreur detect }

    FirstVar   : PVarRec;
    FirstLabel : PLabelRec;
    FirstFile  : PVarFileRec;

    ExtFunct   : Word;       { n de fonction externe }

    FileBuf    : Array[0..511] Of Char;
    LgFileBuf  : Word;
    iFileBuf   : Word;
    FilePosSrc : Longint;


Type InstrStr = String[16];

     InstrRef = (IR_NIL,
  IR_PRINT, IR_IF, IR_DEFBOOL, IR_DEFCHAR, IR_DEFBYTE, IR_DEFSHORT,
  IR_DEFWORD, IR_DEFINT, IR_DEFLONG, IR_DEFREAL, IR_DEFSTR, IR_FREEVAR,
  IR_LABEL, IR_GOTO, IR_INC, IR_DEC, IR_EXEC, IR_DELAY, IR_SOUND,
  IR_NOSOUND, IR_BEEP, IR_RANDOMIZE, IR_FILECLOSE,
  IR_FILERENAME, IR_FILEERASE, IR_FILESEEK, IR_FILETRUNCATE,
                 IR_HALT,
                 IR_END);

Const TabInstr : Array[IR_PRINT..IR_END] Of InstrStr = (
  'PRINT', 'IF', 'DEFBOOL', 'DEFCHAR', 'DEFBYTE', 'DEFSHORT',
  'DEFWORD', 'DEFINT', 'DEFLONG', 'DEFREAL', 'DEFSTR', 'FREEVAR',
  'LABEL', 'GOTO', 'INC', 'DEC', 'EXEC', 'DELAY', 'SOUND',
  'NOSOUND', 'BEEP', 'RANDOMIZE', 'FILECLOSE',
  'FILERENAME', 'FILEERASE', 'FILESEEK', 'FILETRUNCATE',
       'HALT',
       'END'
       );

Type FunctStr = String[16];

     FunctRef = (FR_NIL, FR_EXTERNAL,
  FR_ABS, FR_ADD, FR_SUB, FR_MUL, FR_DIV, FR_MOD, FR_NOT, FR_AND, FR_OR,
  FR_XOR, FR_SHL, FR_SHR, FR_FALSE, FR_TRUE, FR_EQUAL, FR_LESS, FR_ABOVE,
  FR_LESSEQUAL, FR_ABOVEEQUAL, FR_ARCTAN, FR_CONCAT, FR_COPY, FR_COS,
  FR_DELETE, FR_DOSERROR, FR_EXP, FR_FEXPAND, FR_FRAC, FR_HI, FR_INSERT,
  FR_INT, FR_LN, FR_LO, FR_TRUNC, FR_ROUND, FR_STR,
  FR_STRPOINTER, FR_STRINT, FR_STRHEXBYTE, FR_STRHEXWORD, FR_STRHEXLONG,
  FR_STR_INT, FR_STRXINT, FR_STR0INT, FR_STROINT, FR_STRINTO,
  FR_STRUPCASE, FR_STRCOMP, FR_STRNORM,
  FR_STRPLANELEFT, FR_STRPLANERIGHT, FR_STRPLANE,
  FR_GETDATE, FR_STRDATE, FR_STRTIME,
  FR_STRDELCHAR, FR__STRCHGCHAR, FR_STRCHGCHAR, FR_STRTRUNC, FR_STRINSERT,
  FR_STRINSCHAR, FR_STRDEL, FR_STRFILL, FR_STRPOSCHAR, FR_STRONESPACE,
  FR_ALPHACHAR, FR_NUMCHAR, FR_DELCTRLCHAR, FR_VDTIBM, FR_IBMVDT,
  FR_DAYNUMBER, FR_WEEKDAYNUMBER,
  FR_FILEOPEN, FR_FILECREAT, FR_FILECLOSE, FR_FILEPOS,
  FR_FILESIZE, FR_IORESULT, FR_FILEREAD, FR_FILEWRITE, FR_FILEREADSTR,
  FR_FILEWRITESTR, FR_FILEEOF, FR_FILEWRITELN, FR_FILEREADLN,
  FR_PI, FR_POS, FR_RANDOM, FR_SIN, FR_LENGTH, FR_SQR, FR_SQRT, FR_VAL,
                 FR_ERROR
                );

Const TabFunct : Array[FR_ABS..FR_ERROR] Of FunctStr = (
  'ABS', 'ADD', 'SUB', 'MUL', 'DIV', 'MOD', 'NOT', 'AND', 'OR',
  'XOR', 'SHL', 'SHR', 'FALSE', 'TRUE', 'EQUAL', 'LESS', 'ABOVE',
  'LESSEQUAL', 'ABOVEEQUAL', 'ARCTAN', 'CONCAT', 'COPY', 'COS',
  'DELETE', 'DOSERROR', 'EXP', 'FEXPAND', 'FRAC', 'HI', 'INSERT',
  'INT', 'LN', 'LO', 'TRUNC', 'ROUND', 'STR',
  'STRPOINTER','STRINT','STRHEXBYTE','STRHEXWORD','STRHEXLONG',
  'STR_INT', 'STRXINT', 'STR0INT', 'STROINT', 'STRINTO',
  'STRUPCASE', 'STRCOMP', 'STRNORM',
  'STRPLANELEFT', 'STRPLANERIGHT', 'STRPLANE',
  'GETDATE', 'STRDATE', 'STRTIME',
  'STRDELCHAR', '_STRCHGCHAR', 'STRCHGCHAR', 'STRTRUNC', 'STRINSERT',
  'STRINSCHAR', 'STRDEL', 'STRFILL', 'STRPOSCHAR', 'STRONESPACE',
  'ALPHACHAR', 'NUMCHAR', 'DELCTRLCHAR', 'VDTIBM', 'IBMVDT',
  'DAYNUMBER', 'WEEKDAYNUMBER',
  'FILEOPEN', 'FILECREAT', 'FILECLOSE', 'FILEPOS',
  'FILESIZE', 'IORESULT', 'FILEREAD', 'FILEWRITE', 'FILEREADSTR',
  'FILEWRITESTR', 'FILEEOF', 'FILEWRITELN', 'FILEREADLN',
  'PI', 'POS', 'RANDOM', 'SIN', 'LENGTH', 'SQR', 'SQRT', 'VAL',
       'ERROR'
       );

Function  GetErrorStr( Err : ErrorRef ) : String;
Begin
 Case Err Of
  E_NOERROR     : GetErrorStr := 'Pas d''erreur';
  E_INSTR       : GetErrorStr := 'Instruction inconnu';
  E_SYNTAX      : GetErrorStr := 'Syntaxe incorrecte';
  E_VARNAME     : GetErrorStr := 'Nom de variable incorrect';
  E_VAREXIST    : GetErrorStr := 'Nom de variable dj utilis';
  E_MEMORY      : GetErrorStr := 'Plus assez de mmoire';
  E_VARUNKNOWN  : GetErrorStr := 'Variable inconnu';
  E_TYPE        : GetErrorStr := 'Type incorrect';
  E_TOOMANYPARAM: GetErrorStr := 'Trop de paramtres';
  E_PAROUV      : GetErrorStr := '''('' attendu';
  E_PARFER      : GetErrorStr := ''')'' attendu';
  E_VIRGULE     : GetErrorStr := ''','' attendu';
  E_DIVIDE      : GetErrorStr := 'Division par zro';
  E_LABELNAME   : GetErrorStr := 'Nom d''tiquette incorrect';
  E_LABELEXIST  : GetErrorStr := 'Nom d''tiquette utilis';
  E_LABELUNKNOWN: GetErrorStr := 'Etiquette inconnu';
  E_THEN        : GetErrorStr := 'THEN ou GOTO attendu';
  E_BREAK       : GetErrorStr := 'Interruption externe';
  E_BOGUE       : GetErrorStr := 'Erreur interne';
 Else GetErrorStr := 'Erreur (origine indtermine)';
 End;
End;


Procedure SetError( Err : ErrorRef );
Var s : String;
    n : String[10];
Begin
 ErrDetect := TRUE;
 s := '*** Erreur Ligne ';
 Str(LnSt.nLine,n);
 s := s+n+' (Col.';
 Str(LnSt.DebInstr,n);
 s := s+n+',"'+LnSt.Instr+'") : '+GetErrorStr(Err);
 ExternalWriteln(s);
End;


Function FindInstr( Instr : String ) : InstrRef;
Var i : InstrRef;
Begin
 For i := IR_PRINT To IR_END Do
  If TabInstr[i]=Instr Then
   Begin
    FindInstr := i;
    Exit;
   End;
 FindInstr := IR_NIL;
End;

 
Function FindFunct( Funct : String ) : FunctRef;
Var i : FunctRef;
    n : Word;
Begin
 For i := FR_ABS To FR_ERROR Do
  If TabFunct[i]=Funct Then
   Begin
    FindFunct := i;
    Exit;
   End;
 n := ExternalFindFunct( Funct );
 If n<>0 Then
  Begin
   ExtFunct := n;
   FindFunct := FR_EXTERNAL;
  End
 Else FindFunct := FR_NIL;
End;

 
Procedure InitFileBuf;
Begin
 iFileBuf := 0;
 BlockRead(Src,FileBuf,SizeOf(FileBuf),LgFileBuf);
 FilePosSrc := FilePos(Src);
End;

Function  GetFromFileBuf : Char;
Begin
 If LgFileBuf<=iFileBuf Then InitFileBuf; { Recharger }
 GetFromFileBuf := FileBuf[iFileBuf];
 Inc(iFileBuf);
End;


Procedure SkipLn;
Var c : Char;
Begin
 If LgFileBuf=0 Then Exit;

 While TRUE Do
  Begin
   c := GetFromFileBuf;
   If (LgFileBuf=0) Or (c=#26) Then Exit;
   If (c=#$0D) Then
    Begin
     c := GetFromFileBuf;
     If LgFileBuf=0 Then Exit;
     If c=#$0A Then Exit;
    End;
  End;
End;



Function  ReadSrcLn : Boolean;
Var c : Char;
Begin
 LnSt.Line     := '';
 LnSt.iRead    := 1;
 LnSt.Instr    := '';
 LnSt.DebInstr := 1;


 If LgFileBuf=0 Then
  Begin
   ReadSrcLn := FALSE;
   Exit;
  End;

 Inc(LnSt.nLine);
 LnSt.LinePos := ((FilePosSrc-Longint(LgFileBuf))+Longint(iFileBuf));

 ReadSrcLn := TRUE;

 While TRUE Do
  Begin
   c := GetFromFileBuf;
   If (LgFileBuf=0) Or (c=#26) Then Exit;
   If (c=#$0D) Then
    Begin
     c := GetFromFileBuf;
     If LgFileBuf=0 Then Exit;
     If c=#$0A Then Exit;
     If Length(LnSt.Line)<255 Then
      Begin
       Inc(LnSt.Line[0]); LnSt.Line[length(LnSt.Line)] := #$0D;
      End;
    End;
   If Length(LnSt.Line)<255 Then
    Begin
     Inc(LnSt.Line[0]); LnSt.Line[length(LnSt.Line)] := c;
    End;
  End;
End;


Function  SepChar( c : Char ) : Boolean;
Const NbSep = 11;
      ListSep : Array[0..NbSep-1] Of Char =
        (',','(',')',':',';','<','=','>','?','{','}');
Var i : Byte;
Begin
 If c<=' ' Then SepChar := TRUE
 Else
  Begin
   For i := 0 To NbSep-1 Do
    If ListSep[i]=c Then
     Begin
      SepChar := TRUE;
      Exit;
     End;
   SepChar := FALSE;
  End;
End;


Function  GetInstr : String;
Var s    : String;
    c    : Char;
    EndB : Boolean;
Begin
 While (LnSt.iRead<=Length(LnSt.Line)) And
       (LnSt.Line[LnSt.iRead]<=' ') Do Inc(LnSt.iRead);

 LnSt.DebInstr := LnSt.iRead;

 If LnSt.iRead>Length(LnSt.Line) Then
  Begin
   LnSt.Instr := '[EOLN]';
   GetInstr := '';
  End
 Else
  Begin
   c := UpCase(LnSt.Line[LnSt.iRead]);
   If SepChar(c) Then
    Begin
     If c = ';' Then
      Begin
       LnSt.Instr := '[EOLN]';
       GetInstr := '';
       { n'incremente pas ... bloque ici! }
      End
     Else
      Begin
       LnSt.Instr := c;
       GetInstr := c;
       Inc(LnSt.iRead);
      End;
    End
   Else
    Begin
     EndB := FALSE;
     s := '';
     While (LnSt.iRead<=Length(LnSt.Line)) And Not(EndB) Do
      Begin
       c := UpCase(LnSt.Line[LnSt.iRead]);

       If SepChar(c) Then EndB := TRUE
       Else
        Begin
         Inc(s[0]); s[length(s)] := c;
         Inc(LnSt.iRead);
         While (LnSt.iRead<=Length(LnSt.Line)) And (c='''') Do
          Begin
           c := LnSt.Line[LnSt.iRead];
           Inc(s[0]); s[length(s)] := c;
           Inc(LnSt.iRead);
           If c='''' Then
            Begin
             If LnSt.iRead<=Length(LnSt.Line) Then
              Begin
               c := LnSt.Line[LnSt.iRead];
               If c='''' Then
                Begin
                 Inc(s[0]); s[length(s)] := c;
                 Inc(LnSt.iRead);
                End;
              End;
            End
           Else c := '''';
          End;
        End;
      End;
     LnSt.Instr := s;
     GetInstr  := s;
    End;
  End;
End;


{*****************************************************}


Function TradString( var s : String ) : Word;
{ traduit s en chaine, dans s }
{ renvoi 0 si la chaine est traduite, sinon, renvoi la position de l'erreur }
var lg : word;
    read : word;
    c  : char;
  function GetNumber : boolean;
  var x : byte;
  label la,la2,la3;
  begin
    GetNumber := FALSE;
    inc(read);
    if read>length(s) then exit;
    c := s[read];
    if (c>='0') and (c<='9') then
      begin
        x := 0;
        repeat
          x := x*10+(byte(c)-byte('0'));
          inc(read);
          if (read>length(s)) then goto la;
          c := s[read];
        until (c<'0') or (c>'9');
la:     inc(lg);
        s[lg] := char(x);
        GetNumber := TRUE;
      end
    else
      if c='$' then
        begin { saisie Hexa }
          inc(read);
          if read>length(s) then exit;
          c := UpCase(s[read]);
          if ((c>='0') and (c<='9')) or ((c>='A') and (c<='F')) then
            begin
              x := 0;
              repeat
                if c>='A' then x := x*16+((byte(c)-byte('A'))+10)
                else x := x*16+(byte(c)-byte('0'));
                inc(read);
                if read>length(s) then goto la2;
                c := s[read];
              until not(((c>='0') and (c<='9')) or ((c>='A') and (c<='F')));
la2:          inc(lg);
              s[lg] := char(x);
              GetNumber := TRUE;
            end
          else GetNumber := FALSE;
        end
      else
        if c='%' then
          begin { saisie binaire }
            inc(read);
            if read>length(s) then exit;
            c := UpCase(s[read]);
            if ((c>='0') and (c<='1')) then
              begin
                GetNumber := TRUE;
                x := 0;
                repeat
                  x := x*2+(byte(c)-byte('0'));
                  inc(read);
                  if read>length(s) then goto la3;
                  c := s[read];
                until not((c>='0') and (c<='1'));
la3:            inc(lg);
                s[lg] := char(x);
                GetNumber := TRUE;
              end
            else GetNumber := FALSE;
          end
        else GetNumber := FALSE;
  end;
  function GetChar : boolean;
  begin
    GetChar := FALSE;
    while (TRUE) do
      begin
        inc(read);
        if read>length(s) then exit;
        c := s[read];
        if c='''' then
          begin
            inc(read);
            if read>length(s) then
              begin
                GetChar := TRUE; { chaine complete }
                exit;
              end;
            c := s[read];
            if c='''' then
              begin
                inc(lg);
                s[lg] := '''';
              end
            else
              begin
                GetChar := TRUE;
                exit;
              end;
          end
        else
          begin
            inc(lg);
            s[lg] := char(c);
          end;
      end;
  end;
begin
  lg := 0;
  read := 1;

  while read<=length(s) do
    begin
      c := s[read];
      if c='#' then
        begin
          if not GetNumber then
            begin { erreur }
              TradString := read;
              exit;
            end;
        end
      else
        if c='''' then
          begin
            if not GetChar then
              begin
                TradString := read;
                exit;
              end;
          end
        else
          begin
            TradString := read;
            exit;
          end;
    end;
  { chaine complete }
  s[0] := char(lg);
  TradString := 0;
{  writeln('TradString="',s,'"'); }
end;

{ ********** VAR ************ }


Function TestVarName( Name : String ) : Boolean;
Var i : Byte;
Begin
 i := 1;
 While (i<=Length(Name)) And
       ( ((Name[i]>='A') And (Name[i]<='Z')) Or
         (Name[i]='_') Or
         ((Name[i]>='0') And (Name[i]<='9') And (i>1)) ) Do Inc(i);
 TestVarName := (i>Length(Name)) And (Length(Name)<SizeOf(VarStr)) And
                (FindInstr(Name)=IR_NIL) And (FindFunct(Name)=FR_NIL);
End;


Function TestVarDeb( c : Char ) : Boolean;
Begin
 TestVarDeb := ((c>='A') And (c<='Z')) Or (c='_');
End;


Function FindVar( Name : String ) : PVarRec;
Var v : PVarRec;
Begin
 v := FirstVar;
 While v<>NIL Do
  If v^.Name=Name Then
   Begin
    FindVar := v;
    Exit;
   End
  Else v := v^.Next;
 FindVar := NIL;
End;


Function FindCheckVar( Name : String ) : PVarRec;
Var v : PVarRec;
Begin
 v := FindVar(Name);
 If v=NIL Then SetError( E_VARUNKNOWN );
 FindCheckVar := v;
End;


Function FindCheckVarTp( Name : String; Tp : VarRef ) : PVarRec;
Var v : PVarRec;
Begin
 v := FindCheckVar( Name );
 If (v<>NIL) And (v^.Tp<>Tp) Then
  Begin
   SetError( E_TYPE );
   v := NIL;
  End;
 FindCheckVarTp := v;
End;


Function FindCheckVarCardinal( Name : String ) : PVarRec;
Var v : PVarRec;
Begin
 v := FindCheckVar( Name );
 If (v<>NIL) And Not(v^.Tp In VR_Cardinal) Then
  Begin
   SetError( E_TYPE );
   v := NIL;
  End;
 FindCheckVarCardinal := v;
End;


Function AddVar( Name : String; Tp : VarRef ) : Boolean;
Var l, v : PVarRec;
Begin
 l := NIL;
 v := FirstVar;
 While v<>NIL Do
  Begin
   l := v;
   v := v^.Next;
  End;

 New(v);
 If v=NIL Then AddVar := FALSE
 Else
  Begin
   FillChar(v^,SizeOf(v^),0);
   v^.Name := Name;
   v^.Tp   := Tp;
   v^.Str  := NIL;
   v^.Next := NIL;
   Case Tp Of
    VR_REAL : v^.Rl := 0;
    VR_STR : Begin { String ... }
              New(v^.Str);
              If v^.Str=NIL Then { Erreur !!! }
               Begin
                Dispose(v);
                AddVar := FALSE;
                Exit;
               End;
              v^.Str^ := '';
             End;
   Else v^.Lg := 0;   { tous les autres types ... de BOOL  LONG }
   End;
   If l=NIL Then FirstVar := v
   Else l^.Next := v;
   AddVar := TRUE;
  End;
End;


Procedure FreeAllVar;
Var v : PVarRec;
    n : PVarRec;
Begin
 v := FirstVar;
 While v<>NIL Do
  Begin
   n := v^.Next;
   If v^.Str<>NIL Then Dispose(v^.Str);
   Dispose(v);
   v := n;
  End;
 FirstVar := NIL;
End;


Function NewVar( Name : String; Tp : VarRef ) : Boolean;
Begin
 NewVar := FALSE;
 If Not(TestVarName( Name )) Then SetError( E_VARNAME )
 Else
  If FindVar( Name )<>NIL Then SetError( E_VAREXIST )
  Else
   If Not(AddVar( Name, Tp )) Then SetError( E_MEMORY )
   Else NewVar := TRUE;
End;


Function FreeVar( Name : String ) : Boolean;
Var l, v : PVarRec;
Begin
 l := NIL;
 v := FirstVar;
 While (v<>NIL) And (v^.Name<>Name) Do
  Begin
   l := v;
   v := v^.Next;
  End;

 If v=NIL Then
  Begin
   SetError( E_VARUNKNOWN );
   FreeVar := FALSE;
  End
 Else
  Begin
   If l=NIL Then FirstVar := v^.Next
   Else l^.Next := v^.Next;

   If v^.Tp=VR_STR Then Dispose(v^.Str);
   Dispose(v);
   FreeVar := TRUE;
  End;
End;


Function TestLabelName( Name : String ) : Boolean;
Var i : Byte;
Begin
 i := 1;
 While (i<=Length(Name)) And
       ( ((Name[i]>='A') And (Name[i]<='Z')) Or
         (Name[i]='_') Or
         ((Name[i]>='0') And (Name[i]<='9') And (i>1)) ) Do Inc(i);
 TestLabelName := (i>Length(Name)) And (Length(Name)<SizeOf(LabelStr)) And
                  (FindInstr(Name)=IR_NIL) And (FindFunct(Name)=FR_NIL);
End;


Function TestLabelDeb( c : Char ) : Boolean;
Begin
 TestLabelDeb := ((c>='A') And (c<='Z')) Or (c='_');
End;


{ Recherche un label parmi tous ceux dj connu }

Function _FindLabel( Name : String ) : PLabelRec;
Var l : PLabelRec;
Begin
 l := FirstLabel;
 While l<>NIL Do
  If l^.Name=Name Then
   Begin
    _FindLabel := l;
    Exit;
   End
  Else l := l^.Next;
 _FindLabel := NIL;
End;


Function AddLabel( Name : String ) : PLabelRec;
Var l, v : PLabelRec;
Begin
 l := NIL;
 v := FirstLabel;
 While v<>NIL Do
  Begin
   l := v;
   v := v^.Next;
  End;

 New(v);
 If v=NIL Then AddLabel := NIL
 Else
  Begin
   FillChar(v^,SizeOf(v^),0);
   v^.Name    := Name;
   v^.nLine   := LnSt.nLine;
   v^.LinePos := LnSt.LinePos;
   v^.Next    := NIL;
   If l=NIL Then FirstLabel := v
   Else l^.Next := v;
   AddLabel := v;
  End;
End;


Procedure FreeAllLabel;
Var l, n : PLabelRec;
Begin
 l := FirstLabel;
 While l<>NIL Do
  Begin
   n := l^.Next;
   Dispose(l);
   l := n;
  End;
 FirstLabel := NIL;
End;


Function NewLabel( Name : String ) : PLabelRec;
Var l : PLabelRec;
Begin
 NewLabel := NIL;
 If Not(TestLabelName( Name )) Then SetError( E_LABELNAME )
 Else
  Begin

   l := _FindLabel( Name );
   If l<>NIL Then
    Begin
     If l^.nLine<>LnSt.nLine Then SetError( E_LABELEXIST )
     Else NewLabel := l;  { Ce n'est pas une erreur! }
    End
   Else
    Begin
     l := AddLabel( Name );
     If l=NIL Then SetError( E_MEMORY )
     Else NewLabel := l;
    End;
  End;
End;



Function  ExecFunct( n : FunctRef; Var v : VarRec ) : Boolean; Forward;


Function  InstrToBool( Instr : String; Var d : Boolean ) : Boolean;
Var v : PVarRec;
    n : FunctRef;
    z : VarRec;
Begin
 InstrToBool := FALSE;
 If Instr='' Then SetError(E_SYNTAX)
 Else
  Begin
   n := FindFunct(Instr);
   If n<>FR_NIL Then
    Begin
     z.Str  := @Instr;
     If ExecFunct(n,z) Then
      If z.Tp<>VR_BOOL Then SetError(E_TYPE)
      Else
       Begin
        d := z.Bl;
        InstrToBool := TRUE;
       End;
    End
   Else
    If TestVarDeb(Instr[1]) Then
     Begin
      v := FindCheckVarTp(Instr,VR_BOOL);
      If (v<>NIL) Then
       Begin
        d := v^.Bl;
        InstrToBool := TRUE;
       End;
     End
    Else SetError(E_SYNTAX);
  End;
End;


Function  InstrToStr( Instr : String; Var Dest : String ) : Boolean;
Var v : PVarRec;
    n : FunctRef;
    z : VarRec;
Begin
 InstrToStr := FALSE;
 If Instr='' Then SetError(E_SYNTAX)
 Else
  Begin
   n := FindFunct(Instr);
   If n<>FR_NIL Then
    Begin
     z.Str  := @Instr;
     If ExecFunct(n,z) Then
      If z.Tp=VR_STR Then
       Begin
        Dest := Instr;
        InstrToStr := TRUE;
       End
      Else
       If z.Tp=VR_CHAR Then
        Begin
         Dest := z.Ch;
         InstrToStr := TRUE;
        End
       Else SetError(E_TYPE);
    End
   Else
    If TestVarDeb(Instr[1]) Then
     Begin
      v := FindCheckVar(Instr);
      If (v<>NIL) Then
       If v^.Tp=VR_STR Then
        Begin
         Dest := v^.Str^;
         InstrToStr := TRUE;
        End
       Else
        If v^.Tp=VR_CHAR Then
         Begin
          Dest := v^.Ch;
          InstrToStr := TRUE;
         End
        Else SetError(E_TYPE);
     End
    Else
     If TradString(Instr)=0 Then
      Begin
       Dest := Instr;
       InstrToStr := TRUE;
      End
     Else SetError(E_SYNTAX);
  End;
End;


Function  InstrToChar( Instr : String; Var d : Char ) : Boolean;
Begin
 If InstrToStr(Instr,Instr) Then
  If Length(Instr)=1 Then
   Begin
    d := Instr[1];
    InstrToChar := TRUE;
   End
  Else
   Begin
    SetError(E_TYPE);
    InstrToChar := FALSE;
   End
 Else InstrToChar := FALSE;
End;


Function  TestVarCardinal( Var v : VarRec; Var Lg : Longint ) : Boolean;
Begin
 TestVarCardinal := TRUE;
 Case v.Tp Of
  VR_BYTE      : Lg := v.Bt;
  VR_SHORT     : Lg := v.Sh;
  VR_WORD      : Lg := v.Wr;
  VR_INT       : Lg := v.Int;
  VR_LONG      : Lg := v.Lg;
 Else TestVarCardinal := FALSE;
 End;
End;


Function  SizeOfVar( Var v : VarRec ) : Word;
var Lg : Word;
Begin
 Case v.Tp Of
  VR_BOOL, VR_CHAR, VR_BYTE, VR_SHORT : Lg := SizeOf(Byte);
  VR_WORD, VR_INT : Lg := SizeOf(Word);
  VR_LONG : Lg := SizeOf(Longint);
  VR_REAL : Lg := SizeOf(Real);
  VR_STR  : Lg := SizeOf(String);
 Else lg := 0;
 End;
 SizeOfVar := lg;
End;


Function  CheckVarCardinal( Var v : VarRec; Var Lg : Longint ) : Boolean;
Begin
 If TestVarCardinal(v,Lg) Then CheckVarCardinal := TRUE
 Else
  Begin
   CheckVarCardinal := FALSE;
   SetError(E_TYPE);
  End;
End;


Function  TestVarReal( Var v : VarRec; Var Rl : Real ) : Boolean;
Begin
 If v.Tp=VR_REAL Then
  Begin
   Rl := v.Rl;
   TestVarReal := TRUE;
  End
 Else TestVarReal := FALSE;
End;


Function  CheckVarReal( Var v : VarRec; Var Rl : Real ) : Boolean;
Begin
 If TestVarReal(v,Rl) Then CheckVarReal := TRUE
 Else
  Begin
   CheckVarReal := FALSE;
   SetError(E_TYPE);
  End;
End;


Function  CheckTransVarCardinal( Var v : VarRec; Var Lg : Longint ) : Boolean;
Var r : Real;
    x : Longint;
Begin
 If TestVarCardinal(v,Lg) Then CheckTransVarCardinal := TRUE
 Else
  If CheckVarReal(v,r) Then
   Begin
    x := Trunc(r);
    If r=x Then
     Begin {transypage sans perte }
      Lg := x;
      CheckTransVarCardinal := TRUE;
     End
    Else
     Begin
      SetError(E_TYPE);
      CheckTransVarCardinal := FALSE;
     End;
   End
  Else CheckTransVarCardinal := FALSE;
End;


Function  TestTransVarReal( Var v : VarRec; Var r : Real ) : Boolean;
Var x : Longint;
Begin
 If TestVarReal(v,r) Then TestTransVarReal := TRUE
 Else
  If TestVarCardinal(v,x) Then
   Begin
    r := x;
    TestTransVarReal := TRUE;
   End
  Else TestTransVarReal := FALSE;
End;


Function  CheckTransVarReal( Var v : VarRec; Var r : Real ) : Boolean;
Begin
 If TestTransVarReal(v,r) Then CheckTransVarReal := TRUE
 Else
  Begin
   SetError(E_TYPE);
   CheckTransVarReal := FALSE;
  End;
End;


Function  InstrToLong( Instr : String; Var d : Longint ) : Boolean;
Var v : PVarRec;
    x : Longint;
    Err : Word;
    n : FunctRef;
    z : VarRec;
Begin
 InstrToLong := FALSE;
 If Instr='' Then SetError(E_SYNTAX)
 Else
  Begin
   n := FindFunct(Instr);
   If n<>FR_NIL Then
    Begin
     z.Str  := @Instr;
     If ExecFunct(n,z) Then InstrToLong := CheckTransVarCardinal(z,d);
    End
   Else
    If TestVarDeb(Instr[1]) Then
     Begin
      v := FindCheckVar(Instr);
      If (v<>NIL) Then InstrToLong := CheckTransVarCardinal(v^,d);
     End
    Else
     Begin
      Val(Instr,x,Err);
      If Err=0 Then
       Begin
        d := x;
        InstrToLong := TRUE;
       End
      Else SetError(E_SYNTAX);
     End;
  End;
End;


Function  InstrToByte( Instr : String; Var d : Byte ) : Boolean;
Var x : Longint;
Begin
 If InstrToLong(Instr,x) Then
  If (x=Byte(x)) Then
   Begin
    d := Byte(x);
    InstrToByte := TRUE;
   End
  Else
   Begin
    SetError(E_TYPE);
    InstrToByte := FALSE;
   End
 Else InstrToByte := FALSE;
End;


Function  InstrToShort( Instr : String; Var d : ShortInt ) : Boolean;
Var x : Longint;
Begin
 If InstrToLong(Instr,x) Then
  If (x=ShortInt(x)) Then
   Begin
    d := ShortInt(x);
    InstrToShort := TRUE;
   End
  Else
   Begin
    SetError(E_TYPE);
    InstrToShort := FALSE;
   End
 Else InstrToShort := FALSE;
End;


Function  InstrToWord( Instr : String; Var d : Word ) : Boolean;
Var x : Longint;
Begin
 If InstrToLong(Instr,x) Then
  If (x=Word(x)) Then
   Begin
    d := Word(x);
    InstrToWord := TRUE;
   End
  Else
   Begin
    SetError(E_TYPE);
    InstrToWord := FALSE;
   End
 Else InstrToWord := FALSE;
End;


Function  InstrToInt( Instr : String; Var d : Integer ) : Boolean;
Var x : Longint;
Begin
 If InstrToLong(Instr,x) Then
  If (x=Integer(x)) Then
   Begin
    d := Integer(x);
    InstrToInt := TRUE;
   End
  Else
   Begin
    SetError(E_TYPE);
    InstrToInt := FALSE;
   End
 Else InstrToInt := FALSE;
End;


Function  InstrToReal( Instr : String; Var d : Real ) : Boolean;
Var v : PVarRec;
    x : Real;
    Err : Word;
    n : FunctRef;
    z : VarRec;
Begin
 InstrToReal := FALSE;
 If Instr='' Then SetError(E_SYNTAX)
 Else
  Begin
   n := FindFunct(Instr);
   If n<>FR_NIL Then
    Begin
     z.Str  := @Instr;
     If ExecFunct(n,z) Then InstrToReal := CheckTransVarReal(z,d);
    End
   Else
    If TestVarDeb(Instr[1]) Then
     Begin
      v := FindCheckVar(Instr);
      If (v<>NIL) Then InstrToReal := CheckTransVarReal(v^,d);
     End
    Else
     Begin
      Val(Instr,x,Err);
      If Err=0 Then
       Begin
        d := x;
        InstrToReal := TRUE;
       End
      Else SetError(E_SYNTAX);
     End;
  End;
End;


{ convertit un type "var" dans le type compatible le plus grand ... }
{ BOOL -> BOOL }
{ CHAR -> STR -> STR }
{ BYTE -> SHORT -> WORD -> INT -> LONG -> REAL }

Procedure PlaneTp( Var Dest : VarRec );
Var x : Longint;
Begin
 If Dest.Tp=VR_CHAR Then
  Begin { CHAR -> STR }
   Dest.Tp   := VR_STR;
   Dest.Str^ := Dest.Ch;
  End
 Else
  If TestVarCardinal(Dest,x) Then
   Begin
    Dest.Tp  := VR_REAL;
    Dest.Rl  := x;
   End;
End;


Function  InstrToVar( Instr : String; Var Dest : VarRec ) : Boolean;
Var v : PVarRec;
    n : FunctRef;
Begin
 InstrToVar := FALSE;
 If Instr='' Then SetError(E_SYNTAX)
 Else
  Begin
   n := FindFunct(Instr);
   If n<>FR_NIL Then
    Begin
     If ExecFunct(n,Dest) Then
      Begin
       PlaneTp(Dest);
       InstrToVar := TRUE;
      End;
    End
   Else
    If TestVarDeb(Instr[1]) Then
     Begin
      v := FindCheckVar(Instr);
      If (v<>NIL) Then
       Begin
        Dest.Tp    := v^.Tp;
        Case v^.Tp Of
         VR_STR  : Dest.Str^ := v^.Str^;
         VR_REAL : Dest.Rl := v^.Rl;
        Else Dest.Lg := v^.Lg;
        End;

        PlaneTp(Dest);
        InstrToVar := TRUE;
       End;
     End
    Else
     If (Instr[1]='#') Or (Instr[1]='''') Then
      Begin
       Dest.Tp := VR_STR;
       InstrToVar := InstrToStr(Instr,Dest.Str^);
      End
     Else
      Begin
       Dest.Tp := VR_REAL;
       InstrToVar := InstrToReal(Instr,Dest.Rl);
      End;
  End;
End;


Function  TestParOuv( s : String ) : Boolean;
Begin
 TestParOuv := s='(';
End;


Function  TestParFer( s : String ) : Boolean;
Begin
 TestParFer := s=')';
End;

Function  TestVirgule( s : String ) : Boolean;
Begin
 TestVirgule := s=',';
End;

Function  TestEoln( s : String ) : Boolean;
Begin
 TestEoln := s='';
End;


Function  CheckParOuv( s : String ) : Boolean;
Begin
 If TestParOuv(s) Then CheckParOuv := TRUE
 Else
  Begin
   CheckParOuv := FALSE;
   SetError(E_PAROUV);
  End;
End;


Function  CheckParFer( s : String ) : Boolean;
Begin
 If TestParFer(s) Then CheckParFer := TRUE
 Else
  Begin
   CheckParFer := FALSE;
   SetError(E_PARFER);
  End;
End;


Function  CheckVirgule( s : String ) : Boolean;
Begin
 If TestVirgule(s) Then CheckVirgule := TRUE
 Else
  Begin
   CheckVirgule := FALSE;
   SetError(E_VIRGULE);
  End;
End;


Function  CheckEoln( s : String ) : Boolean;
Begin
 If TestEoln(s) Then CheckEoln := TRUE
 Else
  Begin
   CheckEoln := FALSE;
   SetError(E_TOOMANYPARAM);
  End;
End;


{ varreal = ABS(real) }

Procedure Funct_ABS( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := Abs(r);
  End;
End;

{ varreal = ARCTAN(real) }

Procedure Funct_ARCTAN( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := ArcTan(r);
  End;
End;

{ varlong = TRUNC(real) }

Procedure Funct_TRUNC( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   Dest.Lg := Trunc(r);
  End;
End;

{ varlong = ROUND(real) }

Procedure Funct_ROUND( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   Dest.Lg := Round(r);
  End;
End;

{ varreal = long(real) }

Procedure Funct_INT( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_REAL;
   Dest.Rl := Int(r);
  End;
End;

{ varreal = FRAC(real) }

Procedure Funct_FRAC( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := FRAC(r);
  End;
End;

{ varstr = STR(long/real[lg [,dec]]) }

Procedure Funct_STR( Var Dest : VarRec );
Var r   : Real;
    lg  : Longint;
    dec : Longint;
    s   : String;
Begin
 If CheckParOuv(GetInstr) Then
  Begin
   If InstrToVar(GetInstr,Dest) Then
    If TestTransVarReal(Dest,r) Then
     Begin
      lg  := 0;
      dec := 0;
      s := GetInstr;
      If TestVirgule(s) Then
       If Not(InstrToLong(GetInstr,lg)) Then Exit
       Else
        Begin
         s := GetInstr;
         If TestVirgule(s) Then
          If Not(InstrToLong(GetInstr,dec)) Then Exit
          Else s := GetInstr;
        End;
      If CheckParFer(s) Then
       Begin
        Dest.Tp := VR_STR;
        Str(r:lg:dec,Dest.Str^);
       End;
     End
    Else
     If Dest.Tp=VR_BOOL Then
      Begin
       If CheckParFer(GetInstr) Then
        Begin
         If Dest.Bl Then Dest.Str^ := 'TRUE' Else Dest.Str^ := 'FALSE';
         Dest.Tp := VR_STR;
        End;
      End
     Else SetError(E_TYPE);
  End;
End;


{ str = Concat(str[,...]) }

Procedure Funct_CONCAT( Var Dest : VarRec );
Var s : String;
    e : Boolean;
    d : String;
Begin
 If CheckParOuv(GetInstr) Then
  Begin
   d := '';
   e := FALSE;
   Repeat
    s := GetInstr;
    If InstrToStr(s,s) Then
     Begin
      d := d+s;
      s := GetInstr;
     End
    Else e := TRUE;  { Erreur !! }

   Until Not(TestVirgule(s)) Or e;

   If Not(e) And CheckParFer(s) Then
    Begin
     Dest.Tp   := VR_STR;
     Dest.Str^ := d;
    End;
  End;
End;


{ str = Copy(str,pos,lg) }

Procedure Funct_COPY( Var Dest : VarRec );
Var s : String;
    p : Longint;
    lg : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,p) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,lg) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := Copy(s,p,lg);
  End;
End;


{ varreal = COS(real) }

Procedure Funct_COS( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := Cos(r);
  End;
End;


{ str = Delete(str,pos,lg) }

Procedure Funct_DELETE( Var Dest : VarRec );
Var s  : String;
    p  : Longint;
    lg : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,p) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,lg) And
    CheckParFer(GetInstr) Then
  Begin
   Delete(s,p,Lg);
   Dest.Tp   := VR_STR;
   Dest.Str^ := s;
  End;
End;


{ word = DOSERROR }

Procedure Funct_DOSERROR( Var Dest : VarRec );
Begin
 Dest.Tp  := VR_WORD;
 Dest.Wr  := DOSError;
End;


{ varreal = EXP(real) }

Procedure Funct_EXP( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_REAL;
   Dest.Rl := Exp(r);
  End;
End;


{ str = FEXPAND(str) }

Procedure Funct_FEXPAND( Var Dest : VarRec );
Var s : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := s;
  End;
End;


{ str = INSERT(strsource,strdest,pos) }

Procedure Funct_INSERT( Var Dest : VarRec );
Var s, d : String;
    p    : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) And InstrToStr(GetInstr,d) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,p) And
    CheckParFer(GetInstr) Then
  Begin
   Insert(s,d,p);
   Dest.Tp   := VR_STR;
   Dest.Str^ := d;
  End;
End;


{ varreal = LN(real) }

Procedure Funct_LN( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := Ln(r);
  End;
End;


{ varword = HI(word) }

Procedure Funct_HI( Var Dest : VarRec );
Var x : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,x) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_WORD;
   Dest.Wr := Hi(x);
  End;
End;


Procedure Funct_LO( Var Dest : VarRec );
Var x : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,x) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_WORD;
   Dest.Wr := Lo(x);
  End;
End;


Procedure Funct_PI( Var Dest : VarRec );
Begin
 Dest.Tp := VR_REAL;
 Dest.Rl := Pi;
End;


{ BYTE = POS(contenu,contenant) }

Procedure Funct_POS( Var Dest : VarRec );
Var u, a : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,u) And
    CheckVirgule(GetInstr) And InstrToStr(GetInstr,a) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_BYTE;
   Dest.Bt  := Pos(u,a);
  End;
End;



Procedure Funct_RANDOM( Var Dest : VarRec );
Var s : String;
    x : Word;
Begin
 s := GetInstr;
 If s='' Then
  Begin
   Dest.Tp := VR_REAL;
   Dest.Rl := Random;
  End
 Else
  If CheckParOuv(s) And InstrToWord(GetInstr,x) And CheckParFer(GetInstr) Then
   Begin
    Dest.Tp := VR_WORD;
    Dest.Wr := Random(x);
   End;
End;


{ varreal = SIN(real) }

Procedure Funct_SIN( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := Sin(r);
  End;
End;


{ byte = LENGTH(str) }

Procedure Funct_LENGTH( Var Dest : VarRec );
Var s : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_BYTE;
   Dest.Bt := Length(s);
  End;
End;


{ varreal = SQR(real) }

Procedure Funct_SQR( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_REAL;
   Dest.Rl := SQR(r);
  End;
End;


{ varreal = SQRT(real) }

Procedure Funct_SQRT( Var Dest : VarRec );
Var r : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And CheckParFer(GetInstr) Then
  Begin
   Dest.Tp  := VR_REAL;
   Dest.Rl := SQRT(r);
  End;
End;


{ real = VAL( str, errword ) }

Procedure Funct_VAL( Var Dest : VarRec );
Var v   : PVarRec;
    Err : Word;
    r   : Real;
    s   : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) Then
  Begin
   v := FindCheckVarCardinal(GetInstr);
   If (v<>NIL) And CheckParFer(GetInstr) Then
    Begin
     Val(s,r,Err);
     Dest.Tp := VR_REAL;
     Dest.Rl := r;
     v^.Lg   := Err;     { En fait, ca importe peu ... Word Short... }
    End;
  End;
End;


{ real = ADD(real,real[,real,..]) }

Procedure Funct_ADD( Var Dest : VarRec );
Var r : Real;
    s : String;
    a : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And
    CheckVirgule(GetInstr) Then
  Begin
   Repeat
    If InstrToReal(GetInstr,a) Then
     Begin
      r := r+a;
      s := GetInstr;
     End;
   Until ErrDetect Or Not(TestVirgule(s));
   If Not(ErrDetect) And CheckParFer(s) Then
    Begin
     Dest.Tp  := VR_REAL;
     Dest.Rl := r;
    End;
  End;
End;


{ real = SUB(real,real[,real,..]) }

Procedure Funct_SUB( Var Dest : VarRec );
Var r : Real;
    s : String;
    a : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And
    CheckVirgule(GetInstr) Then
  Begin
   Repeat
    If InstrToReal(GetInstr,a) Then
     Begin
      r := r-a;
      s := GetInstr;
     End;
   Until ErrDetect Or Not(TestVirgule(s));
   If Not(ErrDetect) And CheckParFer(s) Then
    Begin
     Dest.Tp  := VR_REAL;
     Dest.Rl := r;
    End;
  End;
End;


{ real = MUL(real,real[,real,..]) }

Procedure Funct_MUL( Var Dest : VarRec );
Var r : Real;
    s : String;
    a : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And
    CheckVirgule(GetInstr) Then
  Begin
   Repeat
    If InstrToReal(GetInstr,a) Then
     Begin
      r := r*a;
      s := GetInstr;
     End;
   Until ErrDetect Or Not(TestVirgule(s));
   If Not(ErrDetect) And CheckParFer(s) Then
    Begin
     Dest.Tp  := VR_REAL;
     Dest.Rl := r;
    End;
  End;
End;


{ real = DIV(real,real[,real,..]) }

Procedure Funct_DIV( Var Dest : VarRec );
Var r : Real;
    s : String;
    a : Real;
Begin
 If CheckParOuv(GetInstr) And InstrToReal(GetInstr,r) And
    CheckVirgule(GetInstr) Then
  Begin
   Repeat
    If InstrToReal(GetInstr,a) Then
     If a=0 Then SetError(E_DIVIDE)
     Else
      Begin
       r := r/a;
       s := GetInstr;
      End;
   Until ErrDetect Or Not(TestVirgule(s));
   If Not(ErrDetect) And CheckParFer(s) Then
    Begin
     Dest.Tp  := VR_REAL;
     Dest.Rl := r;
    End;
  End;
End;


{ long = MOD(long,long) }

Procedure Funct_MOD( Var Dest : VarRec );
Var x, h : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,h) And
    CheckParFer(GetInstr) Then
  If h=0 Then SetError(E_DIVIDE)
  Else
   Begin
    Dest.Tp := VR_LONG;
    Dest.Lg := x Mod h;
   End;
End;


{ long = NOT(long) ou bool = NOT(bool) }

Procedure Funct_NOT( Var Dest : VarRec );
Var x : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToVar(GetInstr,Dest) Then
  If (Dest.Tp=VR_BOOL) Then
   Begin
    If CheckParFer(GetInstr) Then Dest.Bl := Not(Dest.Bl);
   End
  Else
   If CheckTransVarCardinal(Dest,x) And CheckParFer(GetInstr) Then
    Begin
     Dest.Tp := VR_LONG;
     Dest.Lg := Not(x);
    End;
End;


{ long = AND(long,long[,long,..]) or bool=AND(bool,bool[,...]) }

Procedure Funct_AND( Var Dest : VarRec );
Var r : Longint;
    s : String;
    a : Longint;
    b : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToVar(GetInstr,Dest) Then
  If Dest.Tp=VR_BOOL Then
   Begin
    If CheckVirgule(GetInstr) Then
     Begin
      Repeat
       If InstrToBool(GetInstr,b) Then
        Begin
         Dest.Bl := Dest.Bl And b;
         s := GetInstr;
        End;
      Until ErrDetect Or Not(TestVirgule(s));
      If Not(ErrDetect) Then CheckParFer(s);
     End;
   End
  Else
   If CheckTransVarCardinal(Dest,r) And CheckVirgule(GetInstr) Then
    Begin
     Repeat
      If InstrToLong(GetInstr,a) Then
       Begin
        r := r And a;
        s := GetInstr;
       End;
     Until ErrDetect Or Not(TestVirgule(s));
     If Not(ErrDetect) And CheckParFer(s) Then
      Begin
       Dest.Tp := VR_LONG;
       Dest.Lg := r;
      End;
    End;
End;


{ long = OR(long,long[,long,..]) or bool = OR(...) }

Procedure Funct_OR( Var Dest : VarRec );
Var r : Longint;
    s : String;
    a : Longint;
    b : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToVar(GetInstr,Dest) Then
  If Dest.Tp=VR_BOOL Then
   Begin
    If CheckVirgule(GetInstr) Then
     Begin
      Repeat
       If InstrToBool(GetInstr,b) Then
        Begin
         Dest.Bl := Dest.Bl Or b;
         s := GetInstr;
        End;
      Until ErrDetect Or Not(TestVirgule(s));
      If Not(ErrDetect) Then CheckParFer(s);
     End;
   End
  Else
   If CheckTransVarCardinal(Dest,r) And CheckVirgule(GetInstr) Then
    Begin
     Repeat
      If InstrToLong(GetInstr,a) Then
       Begin
        r := r Or a;
        s := GetInstr;
       End;
     Until ErrDetect Or Not(TestVirgule(s));
     If Not(ErrDetect) And CheckParFer(s) Then
      Begin
       Dest.Tp := VR_LONG;
       Dest.Lg := r;
      End;
    End;
End;


{ long = XOR(long,long[,long,..]) or bool= xor(...) }

Procedure Funct_XOR( Var Dest : VarRec );
Var r : Longint;
    s : String;
    a : Longint;
    b : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToVar(GetInstr,Dest) Then
  If Dest.Tp=VR_BOOL Then
   Begin
    If CheckVirgule(GetInstr) Then
     Begin
      Repeat
       If InstrToBool(GetInstr,b) Then
        Begin
         Dest.Bl := Dest.Bl Xor b;
         s := GetInstr;
        End;
      Until ErrDetect Or Not(TestVirgule(s));
      If Not(ErrDetect) Then CheckParFer(s);
     End;
   End
  Else
   If CheckTransVarCardinal(Dest,r) And CheckVirgule(GetInstr) Then
    Begin
     Repeat
      If InstrToLong(GetInstr,a) Then
       Begin
        r := r Xor a;
        s := GetInstr;
       End;
     Until ErrDetect Or Not(TestVirgule(s));
     If Not(ErrDetect) And CheckParFer(s) Then
      Begin
       Dest.Tp := VR_LONG;
       Dest.Lg := r;
      End;
    End;
End;


{ long = SHL(long,long) }

Procedure Funct_SHL( Var Dest : VarRec );
Var x, h : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   Dest.Lg := x Shl h;
  End;
End;


{ long = SHR(long,long) }

Procedure Funct_SHR( Var Dest : VarRec );
Var x, h : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   Dest.Lg := x Shr h;
  End;
End;


Procedure Funct_FALSE_TRUE( Var Dest : VarRec; Ok : Boolean );
Begin
 Dest.Tp := VR_BOOL;
 Dest.Bl := Ok;
End;

{ Boolean ... }

Procedure Funct_Compare( Var Dest : VarRec; TantQue : Byte );
Var Bl : Boolean;
    Rl : Real;
    s  : String;
    rs : Byte;
    ok : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToVar(GetInstr,Dest) And
    CheckVirgule(GetInstr) Then
  Begin
   ok := TRUE;
   Repeat
    s := GetInstr;
    Case Dest.Tp Of
     VR_BOOL : If Not(InstrToBool(s,Bl)) Then Exit
               Else
                Begin
                 If Dest.Bl<Bl Then rs := COMP_LESS
                 Else
                  If Dest.Bl>Bl Then rs := COMP_ABOVE
                  Else rs := COMP_EQUAL;
                 Dest.Bl := Bl;
                End;
     VR_REAL : If Not(InstrToReal(s,Rl)) Then Exit
               Else
                Begin
                 If Dest.Rl<Rl Then rs := COMP_LESS
                 Else
                  If Dest.Rl>Rl Then rs := COMP_ABOVE
                  Else rs := COMP_EQUAL;
                 Dest.Rl := Rl;
                End;
    Else { sinon: VR_STR }
               If Not(InstrToStr(s,s)) Then Exit
               Else
                Begin
                 If Dest.Str^<s Then rs := COMP_LESS
                 Else
                  If Dest.Str^>s Then rs := COMP_ABOVE
                  Else rs := COMP_EQUAL;
                 Dest.Str^ := s;
                End;
    End;

    s := GetInstr;

    ok := ok And ( (rs And TantQue)<>0 ) And ( (rs And Not(TantQue))=0 );

   Until Not(TestVirgule(s));

   If CheckParFer(s) Then
    Begin
     Dest.Tp  := VR_BOOL;
     Dest.Bl  := ok;
    End;
  End;
End;


{ str = StrPointer(long) }

Procedure Funct_STRPOINTER( Var Dest : VarRec );
Var x : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrPointer(Dest.Str^,Pointer(x));
  End;
End;


{ str = StrInt(long) }

Procedure Funct_STRINT( Var Dest : VarRec );
Var x : LongInt;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrInt(Dest.Str^,x);
  End;
End;


{ str = StrHexByte(byte) }

Procedure Funct_STRHEXBYTE( Var Dest : VarRec );
Var x : Byte;
Begin
 If CheckParOuv(GetInstr) And InstrToByte(GetInstr,x) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrHexByte(Dest.Str^,x);
  End;
End;


{ str = StrHexWord(word) }

Procedure Funct_STRHEXWORD( Var Dest : VarRec );
Var x : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,x) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrHexWord(Dest.Str^,x);
  End;
End;


{ str = StrHexLong(long) }

Procedure Funct_STRHEXLONG( Var Dest : VarRec );
Var x : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrHexLong(Dest.Str^,x);
  End;
End;


{ str = Str_Int(long,int) }

Procedure Funct_STR_INT( Var Dest : VarRec );
Var x : LongInt;
    l : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,l) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   Str_Int(Dest.Str^,x,l);
  End;
End;


{ str = StrXInt(long,char,int) }

Procedure Funct_STRXINT( Var Dest : VarRec );
Var x : LongInt;
    c : Char;
    l : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,c) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,l) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrXInt(Dest.Str^,x,c,l);
  End;
End;


{ str = Str0Int(long,int) }

Procedure Funct_STR0INT( Var Dest : VarRec );
Var x : LongInt;
    l : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,l) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   Str0Int(Dest.Str^,x,l);
  End;
End;


{ str = StrOInt(long,int) }

Procedure Funct_STROINT( Var Dest : VarRec );
Var x : LongInt;
    l : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,l) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrOInt(Dest.Str^,x,l);
  End;
End;


{ str = StrIntO(long) }

Procedure Funct_STRINTO( Var Dest : VarRec );
Var x : LongInt;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,x) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrIntO(Dest.Str^,x);
  End;
End;


{ str = StrUpCase(str) }

Procedure Funct_STRUPCASE( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrUpCase(Dest.Str^);
  End;
End;


{ int = StrComp(str,str,bool) }

Procedure Funct_STRCOMP( Var Dest : VarRec );
Var Sujet  : String;
    MinMaj : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToStr(GetInstr,Sujet) And
    CheckVirgule(GetInstr) And InstrToBool(GetInstr,MinMaj) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_INT;
   Dest.Int  := StrComp(Dest.Str^,Sujet,MinMaj);
  End;
End;


{ str = StrNorm(str) }

Procedure Funct_STRNORM( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrNorm(Dest.Str^);
  End;
End;


{ str = StrPlaneLeft(str) }

Procedure Funct_STRPLANELEFT( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrPlaneLeft(Dest.Str^);
  End;
End;


{ str = StrPlaneRight(str) }

Procedure Funct_STRPLANERIGHT( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrPlaneRight(Dest.Str^);
  End;
End;


{ str = StrPlane(str) }

Procedure Funct_STRPLANE( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrPlane(Dest.Str^);
  End;
End;


Procedure GetDateTime( Var DT : DateTime );
Var Ign : Word;  { Ignore }
Begin
 GetDate(DT.Year,DT.Month,DT.Day,Ign);
 GetTime(DT.Hour,DT.Min,DT.Sec,Ign);
 If (DT.Hour=0) And (DT.Min=0) Then
  { Un changement de date peut tre intervenu... }
  GetDate(DT.Year,DT.Month,DT.Day,Ign);
End;


Function  GetPackTime : Longint;
Var DT : DateTime;
    x  : Longint;
Begin
 GetDateTime( DT );
 PackTime( DT, x );
 GetPackTime := x; 
End;


{ long = GetDate }

Procedure Funct_GETDATE( Var Dest : VarRec );
Begin
 Dest.Tp := VR_LONG;
 Dest.Lg := GetPackTime;
End;


{ str = StrDate(long,word) }

Procedure Funct_STRDATE( Var Dest : VarRec );
Var date : Longint;
    md   : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,date) And
    CheckVirgule(GetInstr) And InstrToWord(GetInstr,md) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrPackDate(Dest.Str^,date,md);
  End;
End;


{ str = StrTime(long,word) }

Procedure Funct_STRTIME( Var Dest : VarRec );
Var date : Longint;
    md   : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,date) And
    CheckVirgule(GetInstr) And InstrToWord(GetInstr,md) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   StrPackTime(Dest.Str^,date,md);
  End;
End;


{ str = StrDelChar(str,char) }

Procedure Funct_STRDELCHAR( Var Dest : VarRec );
Var c : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,c) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrDelChar(Dest.Str^,c);
  End;
End;


{ str = _StrChgChar(str,int,int,char,char) }

Procedure Funct__STRCHGCHAR( Var Dest : VarRec );
Var pos : Integer;
    lg  : Integer;
    CEx : Char;
    CNew: Char;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,pos) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,lg) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,CEx) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,CNew) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   _StrChgChar(Dest.Str^,pos,lg,CEx,CNew);
  End;
End;


{ str = StrChgChar(str,char,char) }

Procedure Funct_STRCHGCHAR( Var Dest : VarRec );
Var CEx, CNew : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,CEx) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,CNew) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrChgChar(Dest.Str^,CEx,CNew);
  End;
End;


{ str = StrTrunc(str,int) }

Procedure Funct_STRTRUNC( Var Dest : VarRec );
Var max : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,max) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrTrunc(Dest.Str^,max);
  End;
End;


{ str = StrInsert(str,str,int) }

Procedure Funct_STRINSERT( Var Dest : VarRec );
Var s : String;
    pos : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,pos) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrInsert(Dest.Str^,s,pos);
  End;
End;


{ str = StrInsChar(str,int,int,char) }

Procedure Funct_STRINSCHAR( Var Dest : VarRec );
Var pos, lg : Integer;
    c : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,pos) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,lg) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,c) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrInsChar(Dest.Str^,pos,lg,c);
  End;
End;


{ str = StrDel(str,int,int) }

Procedure Funct_STRDEL( Var Dest : VarRec );
Var pos, nb : Integer;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,pos) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,nb) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrDel(Dest.Str^,pos,nb);
  End;
End;


{ str = StrFill(str,int,int,char) }

Procedure Funct_STRFILL( Var Dest : VarRec );
Var pos, lg : Integer;
    c : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,pos) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,lg) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,c) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrFill(Dest.Str^,pos,lg,c);
  End;
End;


{ word = StrPosChar(str,int,char) }

Procedure Funct_STRPOSCHAR( Var Dest : VarRec );
Var pos : Integer;
    c   : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToInt(GetInstr,pos) And
    CheckVirgule(GetInstr) And InstrToChar(GetInstr,c) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_WORD;
   Dest.Wr := StrPosChar(Dest.Str^,pos,c);
  End;
End;


{ str = StrOneSpace(str) }

Procedure Funct_STRONESPACE( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   StrOneSpace(Dest.Str^);
  End;
End;


{ bool = AlphaChar( char ) }

Procedure Funct_ALPHACHAR( Var Dest : VarRec );
Var c : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToChar(GetInstr,c) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_BOOL;
   Dest.Bl   := AlphaChar(c);
  End;
End;


{ bool = NumChar( char ) }

Procedure Funct_NUMCHAR( Var Dest : VarRec );
Var c : Char;
Begin
 If CheckParOuv(GetInstr) And InstrToChar(GetInstr,c) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_BOOL;
   Dest.Bl   := NumChar(c);
  End;
End;


{ str = DelCtrlChar(str) }

Procedure Funct_DELCTRLCHAR( Var Dest : VarRec );
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   DelCtrlChar(Dest.Str^);
  End;
End;


{ str = VdtIbm(str) }

Procedure Funct_VDTIBM( Var Dest : VarRec );
Var s : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   VdtIbm(s,Dest.Str^);
  End;
End;


{ str = IbmVdt(str) }

Procedure Funct_IBMVDT( Var Dest : VarRec );
Var s : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := '';
   IbmVdt(s,Dest.Str^);
  End;
End;


{ longint = DayNumber(long) }

Procedure Funct_DAYNUMBER( Var Dest : VarRec );
Var date : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,date) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   Dest.Lg := DayNumberPack(date);
  End;
End;


{ word = WeekDayNumber(long) }

Procedure Funct_WEEKDAYNUMBER( Var Dest : VarRec );
Var date : Longint;
Begin
 If CheckParOuv(GetInstr) And InstrToLong(GetInstr,date) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_WORD;
   Dest.Wr := WeekDayPack(date);
  End;
End;


{ ***********  Accs  Disque  ************** }

Procedure AddNewFile( f : PVarFileRec );
Var v, l : PVarFileRec;
Begin
 l := NIL;
 v := FirstFile;
 While v<>NIL Do
  Begin
   l := v;
   v := v^.Next;
  End;

 If l=NIL Then FirstFile := f
 Else l^.Next := f;

 f^.Next := NIL;
End;


Procedure FreeAllFile;
Var f, n : PVarFileRec;
Begin
 f := FirstFile;
 While f<>NIL Do
  Begin
   n := f^.Next;
   Close(f^.f);
   Dispose(f);
   f := n;
  End;
 FirstFile := NIL;
End;



Procedure ExcludeFile( h : Word );
Var v, l : PVarFileRec;
Begin
 l := NIL;
 v := FirstFile;
 While (v<>NIL) And (FileRec(v^.f).Handle<>h) Do
  Begin
   l := v;
   v := v^.Next;
  End;

 If v=NIL Then SetError(E_BOGUE)
 Else
  Begin
   If l=NIL Then FirstFile := v^.Next
   Else l^.Next := v^.Next;
  End;
End;


{ Check ici, va dans IOResult }

Function  CheckFindFile( h : Word ) : PVarFileRec;
Var f : PVarFileRec;
Begin
 f := FirstFile;
 While (f<>NIL) And (FileRec(f^.f).Handle<>h) Do f := f^.Next;
 If f=NIL Then InOutRes := 6;  { Handle invalide }
 CheckFindFile := f;
End;


{ word = FILEOPEN_CREAT( str ) }

Procedure Funct_FILEOPEN_CREAT( Var Dest : VarRec; Creat : Boolean );
Var Name : String;
    f    : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckParFer(GetInstr) Then
  Begin
   New(f);
   If f=NIL Then SetError(E_MEMORY)
   Else
    Begin
     Assign(f^.f,Dest.Str^);
     If Creat Then Rewrite(f^.f,1)
     Else Reset(f^.f,1);
     If IOResult=0 Then
      Begin
       AddNewFile(f);
       Dest.Tp := VR_WORD;
       Dest.Wr := FileRec(f^.f).Handle;
      End
     Else
      Begin { Erreur I/O }
       Dispose(f);
       Dest.Tp := VR_WORD;
       Dest.Wr := 0;
      End;
    End;
  End;
End;


{ long = FILEPOS( word ) }

Procedure Funct_FILEPOS( Var Dest : VarRec );
Var h : Word;
    f : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   f := CheckFindFile( h );
   If f<>NIL Then Dest.Lg := FilePos(f^.f)
   Else Dest.Lg := 0;
  End;
End;


{ long = FILESIZE( word ) }

Procedure Funct_FILESIZE( Var Dest : VarRec );
Var h : Word;
    f : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_LONG;
   f := CheckFindFile( h );
   If f<>NIL Then Dest.Lg := FileSize(f^.f)
   Else Dest.Lg := 0;
  End;
End;


{ word = IORESULT }

Procedure Funct_IORESULT( Var Dest : VarRec );
Begin
 Dest.Tp := VR_WORD;
 Dest.Wr := IoResult;
End;


{ word = FILEREAD_WRITE( word, var [,word] ) }

Procedure Funct_FILEREAD_WRITE( Var Dest : VarRec; W : Boolean );
Var s   : String;
    max : Word;
    h   : Word;
    f   : PVarFileRec;
    r   : Word;
    d   : Pointer;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckVirgule(GetInstr) And InstrToVar(GetInstr,Dest) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,max)) Then Exit;
     If max>SizeOfVar(Dest) Then max := SizeOfVar(Dest);
     s := GetInstr;
    End
   Else max := SizeOfVar(Dest);

   If CheckParFer(s) Then
    Begin
     f := CheckFindFile(h);
     If f<>NIL Then
      Begin
       If Dest.Tp=VR_STR Then d := @Dest.Str^
       Else d := @Dest.Lg;
       If W Then BlockWrite(f^.f,d^,max,r)
       Else BlockRead(f^.f,d^,max,r);
      End
     Else r := 0;

     Dest.Tp := VR_WORD;
     Dest.Wr := r;
    End;
  End;
End;


{ str = FILEREADSTR( word, word ) }

Procedure Funct_FILEREADSTR( Var Dest : VarRec );
Var h   : Word;
    max : Word;
    f   : PVarFileRec;
    r   : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckVirgule(GetInstr) And InstrToWord(GetInstr,max) And
    CheckParFer(GetInstr) Then
  Begin
   If max>SizeOf(String)-1 Then max := SizeOf(String)-1;

   Dest.Tp := VR_STR;

   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     BlockRead(f^.f,Dest.Str^[1],max,r);
     Dest.Str^[0] := Char(r);
    End
   Else Dest.Str^ := '';
  End;
End;


{ word = FILEWRITESTR ( word, str [ , str ... ] ) }

Procedure Funct_FILEWRITESTR( Var Dest : VarRec; AddLn : Boolean );
Var s : String;
    e : Boolean;
    h : Word;
    f : PVarFileRec;
    how : Word;
    r : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckVirgule(GetInstr) Then
  Begin
   how := 0;

   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     e := FALSE;
     Repeat
      s := GetInstr;
      If InstrToStr(s,s) Then
       Begin
        If s<>'' Then
         Begin
          BlockWrite(f^.f,s[1],length(s),r);
          Inc(how,r);
         End;
        s := GetInstr;
       End
      Else e := TRUE;  { Erreur !! }

     Until Not(TestVirgule(s)) Or e;

     If Not(e) And CheckParFer(s) Then
      If AddLn Then
       Begin
        s := #13#10;
        BlockWrite(f^.f,s[1],length(s),r);
        Inc(how,r);
       End;
    End;

   Dest.Tp := VR_WORD;
   Dest.Wr := how;
  End;
End;


{ bool = FILEEOF( word ) }

Procedure Funct_FILEEOF( Var Dest : VarRec );
Var h   : Word;
    f   : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_BOOL;

   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     Dest.Bl := Eof(f^.f);
    End
   Else Dest.Bl := FALSE;
  End;
End;


{ str = FILEREADLN( word ) }

Procedure Funct_FILEREADLN( Var Dest : VarRec );
Var h : Word;
    f : PVarFileRec;
    c : Char;
    r : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_STR;
   Dest.Str^ := '';

   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     While TRUE Do
      Begin
       BlockRead(f^.f,c,SizeOf(c),r);
       If r<>1 Then Exit;   { fin }
       If c=#$0D Then
        Begin
         BlockRead(f^.f,c,SizeOf(c),r);
         If r<>1 Then Exit;    { fin }
         If c=#$0A Then Exit;    { fin }
         If Length(Dest.Str^)<255 Then
          Begin
           Inc(Dest.Str^[0]); Dest.Str^[Length(Dest.Str^)] := #$0D;
          End
         Else Exit;  { fin }
        End;
       If Length(Dest.Str^)<255 Then
        Begin
         Inc(Dest.Str^[0]); Dest.Str^[Length(Dest.Str^)] := c;
        End
       Else Exit; { fin }
      End;
    End;
  End;
End;



Function  ExecFunct( n : FunctRef; Var v : VarRec ) : Boolean;
Begin
 v.Tp := VR_WORD;   { par dfaut }
 v.Wr := 0;

 If v.Str=NIL Then
  Begin
   SetError(E_BOGUE);
  End
 Else
  Begin
   Case n Of
    FR_EXTERNAL : If Not(ExternalExecFunct(ExtFunct,v)) Then SetError(E_BOGUE);
    FR_ABS      : Funct_ABS( v );
    FR_ADD      : Funct_ADD( v );
    FR_SUB      : Funct_SUB( v );
    FR_MUL      : Funct_MUL( v );
    FR_DIV      : Funct_DIV( v );
    FR_MOD      : Funct_MOD( v );
    FR_NOT      : Funct_NOT( v );
    FR_AND      : Funct_AND( v );
    FR_OR       : Funct_OR( v );
    FR_XOR      : Funct_XOR( v );
    FR_SHL      : Funct_SHL( v );
    FR_SHR      : Funct_SHR( v );
    FR_FALSE    : Funct_FALSE_TRUE( v, FALSE );
    FR_TRUE     : Funct_FALSE_TRUE( v, TRUE );
    FR_EQUAL    : Funct_Compare( v, COMP_EQUAL );
    FR_LESS     : Funct_Compare( v, COMP_LESS );
    FR_ABOVE    : Funct_Compare( v, COMP_ABOVE );
    FR_LESSEQUAL: Funct_Compare( v, COMP_LESS+COMP_EQUAL );
    FR_ABOVEEQUAL:Funct_Compare( v, COMP_ABOVE+COMP_EQUAL );
    FR_ARCTAN   : Funct_ARCTAN( v );
    FR_CONCAT   : Funct_CONCAT( v );
    FR_COPY     : Funct_COPY( v );
    FR_COS      : Funct_COS( v );
    FR_DELETE   : Funct_DELETE( v );
    FR_DOSERROR : Funct_DOSERROR( v );
    FR_EXP      : Funct_EXP( v );
    FR_FEXPAND  : Funct_FEXPAND( v );
    FR_FRAC     : Funct_FRAC( v );
    FR_HI       : Funct_HI( v );
    FR_INSERT   : Funct_INSERT( v );
    FR_INT      : Funct_INT( v );
    FR_LN       : Funct_LN( v );
    FR_LO       : Funct_LO( v );
    FR_TRUNC    : Funct_TRUNC( v );
    FR_ROUND    : Funct_ROUND( v );
    FR_STR      : Funct_STR( v );
    FR_STRPOINTER:Funct_STRPOINTER( v );
    FR_STRINT   : Funct_STRINT( v );
    FR_STRHEXBYTE:Funct_STRHEXBYTE( v );
    FR_STRHEXWORD:Funct_STRHEXWORD( v );
    FR_STRHEXLONG:Funct_STRHEXLONG( v );
    FR_STR_INT  : Funct_STR_INT( v );
    FR_STRXINT  : Funct_STRXINT( v );
    FR_STR0INT  : Funct_STR0INT( v );
    FR_STROINT  : Funct_STROINT( v );
    FR_STRINTO  : Funct_STRINTO( v );
    FR_STRUPCASE: Funct_STRUPCASE( v );
    FR_STRCOMP  : Funct_STRCOMP( v );
    FR_STRNORM  : Funct_STRNORM( v );
    FR_STRPLANELEFT:Funct_STRPLANELEFT( v );
    FR_STRPLANERIGHT:Funct_STRPLANERIGHT( v );
    FR_STRPLANE : Funct_STRPLANE( v );
    FR_GETDATE  : Funct_GETDATE( v );
    FR_STRDATE  : Funct_STRDATE( v );
    FR_STRTIME  : Funct_STRTIME( v );
    FR_STRDELCHAR:Funct_STRDELCHAR( v );
    FR__STRCHGCHAR:Funct__STRCHGCHAR( v );
    FR_STRCHGCHAR:Funct_STRCHGCHAR( v );
    FR_STRTRUNC : Funct_STRTRUNC( v );
    FR_STRINSERT: Funct_STRINSERT( v );
    FR_STRINSCHAR:Funct_STRINSCHAR( v );
    FR_STRDEL   : Funct_STRDEL( v );
    FR_STRFILL  : Funct_STRFILL( v );
    FR_STRPOSCHAR:Funct_STRPOSCHAR( v );
    FR_STRONESPACE:Funct_STRONESPACE( v );
    FR_ALPHACHAR: Funct_ALPHACHAR( v );
    FR_NUMCHAR  : Funct_NUMCHAR( v );
    FR_DELCTRLCHAR:Funct_DELCTRLCHAR( v );
    FR_VDTIBM   : Funct_VDTIBM( v );
    FR_IBMVDT   : Funct_IBMVDT( v );
    FR_DAYNUMBER: Funct_DAYNUMBER( v );
    FR_WEEKDAYNUMBER:Funct_WEEKDAYNUMBER( v );
    FR_FILEOPEN : Funct_FILEOPEN_CREAT( v, FALSE );
    FR_FILECREAT: Funct_FILEOPEN_CREAT( v, TRUE );
    FR_FILEPOS  : Funct_FILEPOS( v );
    FR_FILESIZE : Funct_FILESIZE( v );
    FR_IORESULT : Funct_IORESULT( v );
    FR_FILEREAD : Funct_FILEREAD_WRITE( v, FALSE );
    FR_FILEWRITE: Funct_FILEREAD_WRITE( v, TRUE );
    FR_FILEREADSTR:Funct_FILEREADSTR( v );
    FR_FILEWRITESTR:Funct_FILEWRITESTR( v, FALSE );
    FR_FILEEOF  : Funct_FILEEOF( v );
    FR_FILEWRITELN:Funct_FILEWRITESTR( v, TRUE );
    FR_FILEREADLN:Funct_FILEREADLN( v );
    FR_PI       : Funct_PI( v );
    FR_POS      : Funct_POS( v );
    FR_RANDOM   : Funct_RANDOM( v );
    FR_SIN      : Funct_SIN( v );
    FR_LENGTH   : Funct_LENGTH( v );
    FR_SQR      : Funct_SQR( v );
    FR_SQRT     : Funct_SQRT( v );
    FR_VAL      : Funct_VAL( v );
    FR_ERROR    : ;
   Else SetError(E_BOGUE);
   End;
  End;
 ExecFunct := Not(ErrDetect);
End;


Procedure Var_FUNCT( s : String );
Var v : PVarRec;
Begin
 v := FindCheckVar(s);
 If v<>NIL Then
  If GetInstr<>'=' Then SetError(E_SYNTAX)
  Else
   Begin
    s := GetInstr;
    Case v^.Tp Of
     VR_BOOL : InstrToBool(s,v^.Bl);
     VR_CHAR : InstrToChar(s,v^.Ch);
     VR_BYTE : InstrToByte(s,v^.Bt);
     VR_SHORT: InstrToShort(s,v^.Sh);
     VR_WORD : InstrToWord(s,v^.Wr);
     VR_INT  : InstrToInt(s,v^.Int);
     VR_LONG : InstrToLong(s,v^.Lg);
     VR_REAL : InstrToReal(s,v^.Rl);
     VR_STR  : InstrToStr(s,v^.Str^);
    Else SetError(E_BOGUE);
    End;
   End;
End;


{ PRINT (str [ , str ... ] ) }

Procedure Instr_PRINT;
Var s : String;
    d : String;
    e : Boolean;
Begin
 s := GetInstr;
 If s='' Then ExternalWriteln('')
 Else
  If CheckParOuv(s) Then
   Begin
    d := '';
    e := FALSE;
    Repeat
     s := GetInstr;
     If InstrToStr(s,s) Then
      Begin
       d := d+s;
       s := GetInstr;
      End
     Else e := TRUE;  { Erreur !! }

    Until Not(TestVirgule(s)) Or e;

    If Not(e) And CheckParFer(s) And CheckEoln(GetInstr) Then
      ExternalWriteln(d);
   End;
End;


{ DEFINT varint varint ... }

Procedure Instr_DEFXXX( Tp : VarRef );
Var s : String;
    e : Boolean;
Begin
 e := FALSE;
 Repeat
  s := GetInstr;
  If s<>'' Then e := Not(NewVar(s,Tp));
 Until (s='') Or e;
End;


{ FREEVAR var var ... }

Procedure Instr_FREEVAR;
Var s : String;
    e : Boolean;
Begin
 e := FALSE;
 Repeat
  s := GetInstr;
  If s<>'' Then e := FreeVar(s);
 Until (s='') Or Not(e);
End;


{ LABEL Label }

Procedure Instr_LABEL;
Var s : String;
Begin
 s := GetInstr;
 If NewLabel(s)<>NIL Then CheckEoln(GetInstr);
End;


{ si le label n'existe pas parmi ceux connu, alors on recherche plus loin }


Function FindCheckLabel( Name : String ) : PLabelRec;
Var l    : PLabelRec;
    Save : LineStat;
    s    : String;
Begin
 l := FirstLabel;
 While (l<>NIL) And (l^.Name<>Name) Do l := l^.Next;

 If l=NIL Then
  Begin { recherche sur disk ... }
   Save := LnSt;   { Sauve tat courant }

   While (l=NIL) And (LgFileBuf>0) And Not(ErrDetect) And ReadSrcLn Do
    Begin
     s := GetInstr;
     If s<>'' Then
      Begin
       If FindInstr(s)=IR_LABEL Then
        Begin
         s := GetInstr;
         l := NewLabel(s);
         If ((l<>NIL) And Not(CheckEoln(GetInstr))) Or
            (l^.Name<>Name) Then l := NIL;
        End;
      End;
    End;

   If Not(ErrDetect) And (l=NIL) Then
    Begin
     SetError(E_LABELUNKNOWN);
    End;

   { Retablir positionnement }

   LnSt := Save;
   Seek(Src,LnSt.LinePos);
   InitFileBuf;
   SkipLn;
  End;

 FindCheckLabel := l;
End;



Procedure SeekToLabel( nLine : Word; LinePos : Longint );
Begin
 LnSt.nLine   := nLine-1;
 Seek(Src,LinePos);
 InitFileBuf;
(* SkipLn; *)

 ReadSrcLn;    { Passe  la suivante }
 While Not(TestEoln(GetInstr)) Do ;

End;


{ GOTO Label }

Procedure Instr_GOTO;
Var l : PLabelRec;
Begin

 l := FindCheckLabel(GetInstr);

 If (l<>NIL) And CheckEoln(GetInstr) Then
  Begin
   SeekToLabel(l^.nLine,l^.LinePos);
  End;
End;


Procedure Instr_IF;
Var s : String;
    l : PLabelRec;
    b : Boolean;
Begin
 If InstrToBool(GetInstr,b) Then
  Begin
   s := GetInstr;
   If (s='THEN') or (s='GOTO') Then
    Begin
     l := FindCheckLabel(GetInstr);
     If (l<>NIL) And CheckEoln(GetInstr) Then
      Begin
       If b Then SeekToLabel(l^.nLine,l^.LinePos);
      End;
    End
   Else SetError(E_THEN);
  End;
End;


{ INC (long [, how]) }

Procedure Instr_INC;
Var s   : String;
    x   : Longint;
    v   : PVarRec;
    Lg  : Longint;
Begin
 If CheckParOuv(GetInstr) Then
  Begin
   v := FindCheckVar(GetInstr);
   If (v<>NIL) And CheckTransVarCardinal(v^,Lg) Then
    Begin
     s := GetInstr;
     If TestParFer(s) Then v^.Lg := Lg+1
     Else
      If CheckVirgule(s) And InstrToLong(GetInstr,x) And
         CheckParFer(GetInstr) And CheckEoln(GetInstr) Then v^.Lg := Lg+x;
    End;
  End;
End;


{ DEC (long [,how]) }

Procedure Instr_DEC;
Var s   : String;
    x   : Longint;
    v   : PVarRec;
    Lg  : Longint;
Begin
 If CheckParOuv(GetInstr) Then
  Begin
   v := FindCheckVar(GetInstr);
   If (v<>NIL) And CheckTransVarCardinal(v^,Lg) Then
    Begin
     s := GetInstr;
     If TestParFer(s) Then v^.Lg := Lg-1
     Else
      If CheckVirgule(s) And InstrToLong(GetInstr,x) And
         CheckParFer(GetInstr) And CheckEoln(GetInstr) Then v^.Lg := Lg-x;
    End;
  End;
End;


{ EXEC( str, str ) }

Procedure Instr_EXEC;
Var Chemin,  LigneCmd : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Chemin) And
    CheckVirgule(GetInstr) And InstrToStr(GetInstr,LigneCmd) And
    CheckParFer(GetInstr) And CheckEoln(GetInstr) Then
  Begin
   SwapVectors;
   Exec(Chemin,LigneCmd);
   SwapVectors;
  End;
End;


{ Delay( word ) }

Procedure Instr_DELAY;
Var x : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,x) And
    CheckParFer(GetInstr) And CheckEoln(GetInstr) Then
  Begin
   Delay(x);
  End;
End;


Procedure Instr_NOSOUND;
Begin
 NoSound;
End;


{ SOUND(hz[,delay]) }

Procedure Instr_SOUND;
Var x : Word;
    d : Word;
    s : String;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,x) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If InstrToWord(GetInstr,d) And CheckParFer(GetInstr) Then
      Begin
       Sound(x);
       Delay(d);
       NoSound;
      End;
    End
   Else If CheckParFer(s) And CheckEoln(GetInstr) Then Sound(x);
  End;
End;


Procedure Instr_BEEP;
Begin
 Sound(800);
 Delay(250);
 NoSound;
End;


Procedure Instr_RANDOMIZE;
Begin
 Randomize;
End;
 
{ FILECLOSE(handle)  }

Procedure Instr_FILECLOSE;
Var h : Word;
    f : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     Close(f^.f);
     ExcludeFile(h);
     Dispose(f);
    End;
  End;
End;


{ FILERENAME(str,str) }

Procedure Instr_FILERENAME;
Var f : File;
    Ex  : String;
    New : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Ex) And
    CheckVirgule(GetInstr) And InstrToStr(GetInstr,New) And
    CheckParFer(GetInstr) Then
  Begin
   Assign(f,Ex);
   Rename(f,New);
  End;
End;


{ FILEERASE(str) }

Procedure Instr_FILEERASE;
Var f : File;
    Name : String;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Name) And
    CheckParFer(GetInstr) Then
  Begin
   Assign(f,Name);
   Erase(f);
  End;
End;


{ FILESEEK(word,long) }

Procedure Instr_FILESEEK;
Var h : Word;
    p : Longint;
    f : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckVirgule(GetInstr) And InstrToLong(GetInstr,p) And
    CheckParFer(GetInstr) Then
  Begin
   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     Seek(f^.f,p);
    End;
  End;
End;


{ FILETRUNCATE(word) }

Procedure Instr_FILETRUNCATE;
Var h : Word;
    f : PVarFileRec;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,h) And
    CheckParFer(GetInstr) Then
  Begin
   f := CheckFindFile(h);
   If f<>NIL Then
    Begin
     Truncate(f^.f);
    End;
  End;
End;


Procedure Instr_END;
Begin
 If CheckEoln(GetInstr) Then EndDetect := TRUE;
End;


Procedure AnalyseSrcLine;
Var s : String;
    n : FunctRef;
    v : VarRec;
Begin

 s := GetInstr;
 If s<>'' Then
  Begin
   Case FindInstr(s) Of
    IR_NIL       : Begin
                    n := FindFunct(s);
                    If n<>FR_NIL Then
                     Begin
                      v.Str := @s;     { prepare variable "poubelle" }
                      ExecFunct(n,v);  { ignore result }
                     End
                    Else
                     If TestVarDeb(s[1]) Then Var_FUNCT(s)
                     Else SetError(E_SYNTAX);
                   End;
    IR_PRINT     : Instr_PRINT;
    IR_IF        : Instr_IF;
    IR_DEFBOOL   : Instr_DEFXXX(VR_BOOL);
    IR_DEFCHAR   : Instr_DEFXXX(VR_CHAR);
    IR_DEFBYTE   : Instr_DEFXXX(VR_BYTE);
    IR_DEFSHORT  : Instr_DEFXXX(VR_SHORT);
    IR_DEFWORD   : Instr_DEFXXX(VR_WORD);
    IR_DEFINT    : Instr_DEFXXX(VR_INT);
    IR_DEFLONG   : Instr_DEFXXX(VR_LONG);
    IR_DEFREAL   : Instr_DEFXXX(VR_REAL);
    IR_DEFSTR    : Instr_DEFXXX(VR_STR);
    IR_FREEVAR   : Instr_FREEVAR;
    IR_LABEL     : Instr_LABEL;
    IR_GOTO      : Instr_GOTO;
    IR_INC       : Instr_INC;
    IR_DEC       : Instr_DEC;
    IR_EXEC      : Instr_EXEC;
    IR_DELAY     : Instr_DELAY;
    IR_SOUND     : Instr_SOUND;
    IR_NOSOUND   : Instr_NOSOUND;
    IR_BEEP      : Instr_BEEP;
    IR_RANDOMIZE : Instr_RANDOMIZE;
    IR_FILECLOSE : Instr_FILECLOSE;
    IR_FILERENAME: Instr_FILERENAME;
    IR_FILEERASE : Instr_FILEERASE;
    IR_FILESEEK  : Instr_FILESEEK;
    IR_FILETRUNCATE:Instr_FILETRUNCATE;
    IR_HALT,
    IR_END       : Instr_END;
   Else SetError(E_INSTR);
   End;
  End;

 If Not(ErrDetect) Then CheckEoln(GetInstr);
End;

{ Renvoi FALSE si fichier introuvable !!! }

Function  TelixInit( Name : String ) : Boolean;
Begin
 Assign(Src,Name);
 Reset(Src,1);
 If IoResult=0 Then
  Begin
   InitFileBuf;
   LnSt.nLine := 0;

   FirstVar   := NIL;
   FirstLabel := NIL;
   FirstFile  := NIL;

   ErrDetect  := FALSE;
   EndDetect  := FALSE;

   TelixInit := TRUE;
  End
 Else TelixInit := FALSE;
End;


Function  TelixExecute : Boolean;
Begin
 If (LgFileBuf>0) And Not(EndDetect) And
    Not(ErrDetect) And ReadSrcLn Then
  Begin
   AnalyseSrcLine;
   TelixExecute := TRUE;
  End
 Else TelixExecute := FALSE;
End;


Function  TelixGetnLine : Word;
Begin
 TelixGetnLine := LnSt.nLine+1;
End;


Procedure TelixDone;
Begin
 NoSound;
 FreeAllVar;
 FreeAllLabel;
 FreeAllFile;
 Close(Src);
End;


Procedure TelixEndDetect;
Begin
 EndDetect := TRUE;
End;


(*
Procedure Main;
Begin
 If ParamStr(1)='' Then Assign(Src,'TEST.TLX')
 Else Assign(Src,ParamStr(1));

 Reset(Src,1);
 If IoResult=0 Then
  Begin
   InitFileBuf;
   LnSt.nLine := 0;

   FirstVar   := NIL;
   FirstLabel := NIL;
   FirstFile  := NIL;

   ErrDetect  := FALSE;
   EndDetect  := FALSE;

   While (LgFileBuf>0) And Not(EndDetect) And
         Not(ErrDetect) And ReadSrcLn Do AnalyseSrcLine;

   NoSound;
   Close(Src);
  End
 Else Writeln('Impossible d''ouvrir !');
End;

Begin
 Assign(Video,'');
 ReWrite(Video);

 Writeln(Video,'TELIX  1.0  Copyright (c) 1991,92 W.M.Edition');
 Writeln(Video);

 Main;

 Close(Video);
End;
*)


Function InternalFindFunct( Instr : String ) : Word; Far;
Begin
 InternalFindFunct := 0;
End;


Function InternalExecFunct( n : Word; Var v : VarRec ) : Boolean; Far;
Begin
 InternalExecFunct := FALSE;
End;


Procedure InternalWriteln( s : String ); Far;
Begin
 Writeln(s);
End;


Begin
 ExternalFindFunct := InternalFindFunct;
 ExternalExecFunct := InternalExecFunct;
 ExternalWriteln   := InternalWriteln;

 FirstVar   := NIL;
 FirstLabel := NIL;
 FirstFile  := NIL;

 LgFileBuf  := 0;
End.
