{$A+,B-,D+,E-,F-,I-,L+,N-,O-,R-,S-,V- }

(***********************************************)
(*                                             *)
(*              VIDEO2 V1.0 02/12/88           *)
(*                                             *)
(***********************************************)

Unit VIDEO2;

interface (*--------------------*)

uses Dos { ,Crt };

Const VMODE_UNDEF = 0;
      VMODE_MDA   = 1;
      VMODE_CGA   = 2;

type Zn_Rec = record
                X,Y,Lg,Ht : byte;
              end;

type DtScr_Rec = record
                   case BYTE of
                     TRUE  : (Car,Att : byte);
                     FALSE : (Dt      : word);
                 end;
     MemScr_Map = array[0..24,0..79] of DtScr_Rec;

var MemScr   : ^MemScr_Map; (* ecran actif      *)

const CDRNORM = 1;
      CDRDOUBLE = 2;
      CDRMIXTE = 3;
      CDRMIXINV = 4;

type cadre = record
               hg,hh,hd,
               vg,   vd,
               bg,bh,bd : char;
             end;

const cdrtab : array[1..4] of cadre = (
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ),
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ),
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ),
       ( hg:'';hh:'';hd:'';
         vg:'';       vd:'';
         bg:'';bh:'';bd:'' ) );

procedure FromScr(dest : pointer; x,y,Lg : byte);
procedure ToScr(source : pointer; x,y,Lg : byte);
procedure WrtDt( data,x,y,attrib :byte);
procedure FillWord(var source; Lg,Data : word);
procedure RbtXY(var X,Y : byte);
procedure RbtZn(var Zn : Zn_Rec);
procedure RbtZc(var x,y,lg,ht : byte);
procedure FillZn(Zn : Zn_Rec; Car,Att : byte);
procedure FillZc(x,y,lg,ht,Car,Att : byte);
procedure ClrZn(Zn : Zn_Rec; Att : byte);
procedure ClrZc(x,y,lg,ht,Att : byte);
procedure AspZn(Zn : Zn_Rec; Att : byte);
procedure AspZc(x,y,lg,ht,Att : byte);
procedure CdrZn( Zn : Zn_Rec; Cdr : cadre; att : byte);
procedure CdrZc(x,y,lg,ht : byte; Cdr : cadre; att : byte);
procedure CCdrZn(Zn : Zn_Rec; style : byte; att : byte);
procedure CCdrZc(x,y,lg,ht : byte; style : byte; att : byte);

procedure DessWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
procedure DessWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
procedure PushWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
procedure PushWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
procedure PopWd;

procedure ZnUp(Zn : Zn_Rec; LineUp,Att : byte);
procedure ZcUp(x,y,lg,ht : byte; LineUp,Att : byte);
procedure ZnDn(Zn : Zn_Rec; LineDn,Att : byte);
procedure ZcDn(x,y,lg,ht : byte; LineDn,Att : byte);
procedure CurXY(X,Y : byte);
procedure CurFormat(Deb,Fin : byte);
function GetVideoMode : byte;
procedure SetVideoMode(what : byte);
function GetVideoCarte : byte;
function GetAdrScr : pointer;
function GetBestVideoMode : byte;
procedure WrtScr(texte : string; X,Y,Att : byte);

procedure PushZn(Zn : Zn_Rec);
procedure PushZc(x,y,lg,ht : byte);
procedure PopZn;
procedure PopNoZn;

const MX_FILE_ZN = 40;
type FileZone = record
                  open : boolean;
                  Zn : Zn_Rec;
                  case WORD of
                    TRUE : (ofs,seg : word);
                    FALSE : (Adr : pointer);
                end;

var FileZn : array[1..MX_FILE_ZN] of FileZone;

procedure CloseZn(NumFich : byte);
function SaveZn(Zn : Zn_Rec) : byte;
function SaveZc(x,y,lg,ht : byte) : byte;
procedure RstZn(NumFich : byte);
procedure RstZnTo(NumFich,x,y : byte);

Function  OpenVideoSys( VMode : Byte; neige : boolean) : Byte;
procedure CloseVideoSys;
Procedure CurOFF;
Procedure CurON;
Procedure CurSmall;
Procedure CurBig;
Procedure CurPos( column, row : Byte );

Procedure KeepVideo;
Procedure ResumeVideo;


implementation (*------------------------*)

Const
      INTVIDEO    = $10;

var LastVideoMode : byte;
    VideoMode     : Byte;

    ScrSnow  : boolean;
    ScrLg    : byte;
    ScrHt    : byte;
    ScrAdr   : pointer;

(*$L VIDEO2KIT.OBJ *)

procedure WrtDt( data,x,y,attrib : byte); external;
procedure WrtScr(texte : string; X,Y,Att : byte); external;
procedure FromScr(dest : pointer; x,y,lg : byte); external;
procedure ToScr(source : pointer; x,y,lg : byte); external;

(* procedure ToScr(var source,destination; Lg : word);
begin
  if ScrSnow then
    inline($1E/$55/$BA/$DA/$03/
           $C5/$B6/ source /
           $C4/$BE/ destination /
           $8B/$8E/ Lg /
           $E3/$17/
           $FC/
           $AD/$89/$C5/$B4/$09/$EC/$D0/$D8/$72/$FB/$FA/$EC/$20/$E0/$74/$FB/
           $89/$E8/$AB/$FB/$E2/$EA/$5D/$1F )
  else
    Move(source,destination,Lg*2);
end; *)

procedure RbtXY(var X,Y : byte);
begin
  if X>79 then X := 79;
  if Y>24 then Y := 24;
end;

procedure FillWord(var source; Lg,Data : word);
begin
  inline($06/$C4/$BE/ source /$8B/$8E/ Lg /$8B/$86/ Data /
         $E3/$03/$FC/$F3/$AB/$07 );
end;

procedure RbtZn(var Zn : Zn_Rec);
begin
  with Zn do
    begin
      RbtXY(X,Y);
      if (X+Lg)>80 then Lg := 80-X;
      if (Y+Ht)>25 then Ht := 25-Y;
    end;
end;

procedure RbtZc(var x,y,lg,ht : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  RbtZn(Zn);
  x := Zn.x;
  y := Zn.y;
  lg := Zn.lg;
  ht := Zn.ht;
end;

procedure FillZn(Zn : Zn_Rec; Car,Att : byte);
var Line  : array[0..79] of DtScr_Rec;
    Temp  : DtScr_Rec;
    Index : byte;
begin
  RbtZn(Zn);
  Temp.Car := Car;
  Temp.Att := Att;
  FillWord(Line[Zn.X],Zn.Lg,Temp.Dt);
  for Index := Zn.Y to Zn.Y+Zn.Ht-1 do
    ToScr(@Line[Zn.X],Zn.X,Index,Zn.Lg);
end;

procedure FillZc(x,y,lg,ht,Car,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  FillZn(Zn,Car,Att);
end;

procedure ClrZn(Zn : Zn_Rec; Att : byte);
begin
  FillZn(Zn,32,Att);
end;

procedure ClrZc(x,y,lg,ht,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  ClrZn(Zn,Att);
end;

procedure CdrZn( Zn : Zn_Rec; Cdr : cadre; att : byte);
var texte : string[80];
    i : byte;
begin
  RbtZn(Zn);
  if (Zn.Lg>1) and (Zn.Ht>1) then
    begin
      texte[1] := cdr.hg;
      FillChar(texte[2],Zn.Lg-2,cdr.hh);
      texte[Zn.Lg] := cdr.hd;
      texte[0] := char(Zn.Lg);
      WrtScr(texte,Zn.X,Zn.Y,att);
      texte[1] := cdr.bg;
      FillChar(texte[2],Zn.Lg-2,cdr.bh);
      texte[Zn.Lg] := cdr.bd;
      texte[0] := char(Zn.Lg);
      WrtScr(texte,Zn.X,Zn.Y+Zn.Ht-1,att);
      for i := 1 to Zn.Ht-2 do
        begin
          WrtDt(byte(cdr.vg),Zn.X,Zn.Y+i,att);
          WrtDt(byte(cdr.vd),Zn.X+Zn.Lg-1,Zn.Y+i,att);
        end;
    end;
end;

procedure CdrZc( x,y,lg,ht : byte; Cdr : cadre; att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  CdrZn(Zn,Cdr,att);
end;

procedure CCdrZn(Zn : Zn_Rec; style : byte; att : byte);
begin
  CdrZn(Zn,cdrtab[style],att);
end;

procedure CCdrZc(x,y,lg,ht : byte; style : byte; att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  CdrZn(Zn,cdrtab[style],att);
end;

procedure AspZn(Zn : Zn_Rec; Att : byte);
var line : array[1..80] of DtScr_Rec;
    i : byte;
    l : byte;
begin
  RbtZn(Zn);
  for l := Zn.Y to Zn.Y+Zn.Ht-1 do
    begin
      FromScr(@line,Zn.x,l,Zn.Lg);
      for i := 1 to Zn.Lg do line[i].att := att;
      ToScr(@line,Zn.X,l,Zn.Lg);
    end;
end;

procedure AspZc(x,y,lg,ht : byte; Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  AspZn(Zn,Att);
end;

procedure ZnUp(Zn : Zn_Rec; LineUp,Att : byte);
var Reg : registers;
begin
  RbtZn(Zn);
  Reg.AH := $06;
  Reg.AL := LineUp;
  Reg.CH := Zn.Y;
  Reg.CL := Zn.X;
  Reg.DH := Zn.Y+Zn.Ht-1;
  Reg.DL := Zn.X+Zn.Lg-1;
  Reg.BH := Att;
  Intr($10,Reg);
end;

procedure ZcUp(x,y,lg,ht : byte; LineUp,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  ZnUp(Zn,LineUp,Att);
end;

procedure ZnDn(Zn : Zn_Rec; LineDn,Att : byte);
var Reg : registers;
begin
  RbtZn(Zn);
  Reg.AH := $07;
  Reg.AL := LineDn;
  Reg.CH := Zn.Y;
  Reg.CL := Zn.X;
  Reg.DH := Zn.Y+Zn.Ht-1;
  Reg.DL := Zn.X+Zn.Lg-1;
  Reg.BH := Att;
  Intr($10,Reg);
end;

procedure ZcDn(x,y,lg,ht : byte; LineDn,Att : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  ZnDn(Zn,LineDn,Att);
end;

procedure CurXY(X,Y : byte);
var Reg : registers;
begin
  RbtXY(X,Y);
  Reg.AH := $02;
  Reg.DH := Y;
  Reg.DL := X;
  Reg.BH := 0;
  Intr($10,Reg);
end;

procedure CurFormat(Deb,Fin : byte);
var Reg : registers;
begin
  Reg.AH := $01;
  Reg.CH := Deb and 31;
  Reg.CL := Fin and 31;
  Intr($10,Reg);
end;

function GetVideoMode : byte;
var Reg : registers;
begin
  Reg.AH := $0F;
  Intr($10,Reg);
  GetVideoMode := Reg.AL;
end;

procedure SetVideoMode(what : byte);
var Reg : registers;
begin
  Reg.AX := what;
  Intr($10,Reg);
end;

const NoCarte   = 0;
      Mono40x25 = 1;
      Coul80x25 = 2;
      Mono80x25 = 3;

const Mono = 7; (* Mono *)
      C80  = 3; (* Coul80x25 *)

function GetVideoCarte : byte;
var Reg : registers;
begin
  Intr($11,Reg);
  GetVideoCarte := (Reg.AL and (16+32)) shr 4;
end;

function GetAdrScr : pointer;
begin
  if GetVideoCarte=Coul80x25 then GetAdrScr := ptr($B800,$0000)
  else GetAdrScr := ptr($B000,$0000)
end;

function GetBestVideoMode : byte;
begin
  if GetVideoCarte=Coul80x25 then GetBestVideoMode := C80
  else GetBestVideoMode := Mono;
end;

(**** PILE_ZN ****)

Type PtrRec = Record Ofs, Seg : Word; End;

     PPileZnRec = ^PileZnRec;

     PileZnRec = Record
       Zn   : Zn_Rec;
       Adr  : Pointer;
       Next : PPileZnRec;
      End;

Var FirstPileZn : PPileZnRec;
    LastPileZn  : PPileZnRec;

procedure PushZn(Zn : Zn_Rec);
(* sauvegarde une zone de l'ecran sur une pile *)
var Line : Byte;
    Adr  : Pointer;
    z    : PPileZnRec;
begin
 New(z);
 If z<>NIL Then
  Begin

   RbtZn(Zn);
   GetMem(Adr,Zn.Ht*Zn.Lg*2);
   If Adr<>NIL Then
    Begin

     for Line := Zn.Y to Zn.Y+Zn.Ht-1 do
       FromScr(Ptr(PtrRec(Adr).Seg,PtrRec(Adr).Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
               Zn.x,Line,Zn.Lg);

     If FirstPileZn=NIL Then FirstPileZn := z
     Else LastPileZn^.Next := z;

     LastPileZn := z;

     z^.Zn   := Zn;
     z^.Adr  := Adr;
     z^.Next := NIL;

     Exit;

    End;

   Dispose(z);
  End;
end;


procedure PushZc(x,y,lg,ht : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  PushZn(Zn);
end;

procedure PopZn;
(* restitue la premiere fenetre de la pile *)
var Line : byte;
    ADer : PPileZnRec;
    z    : PPileZnRec;
begin
  z := FirstPileZn;
  If z<>NIL Then
   Begin

    ADer := NIL;
    While z^.Next<>NIL Do
     Begin
      ADer := z;
      z := z^.Next;
     End;

    for Line := z^.Zn.Y to z^.Zn.Y+z^.Zn.Ht-1 do
      ToScr(ptr(PtrRec(z^.Adr).Seg,PtrRec(z^.Adr).Ofs+(Line-z^.Zn.Y)*(z^.Zn.Lg*2)),
            z^.Zn.X,Line,z^.Zn.Lg);

    FreeMem(z^.Adr,z^.Zn.Ht*z^.Zn.Lg*2);

    Dispose(z);

    If ADer=NIL Then FirstPileZn := NIL
    Else ADer^.Next := NIL;
    LastPileZn := ADer;

   End;
end;

procedure PopNoZn;
(* supprime la premiere fenetre de la pile *)
var ADer : PPileZnRec;
    z    : PPileZnRec;
begin
  z := FirstPileZn;
  If z<>NIL Then
   Begin

    ADer := NIL;
    While z^.Next<>NIL Do
     Begin
      ADer := z;
      z := z^.Next;
     End;

    FreeMem(z^.Adr,z^.Zn.Ht*z^.Zn.Lg*2);

    Dispose(z);

    If ADer=NIL Then FirstPileZn := NIL
    Else ADer^.Next := NIL;
    LastPileZn := ADer;

   End;
end;

function FirstFileZn(open : boolean) : byte;
(* retourne le numero du premier fichier ouvert ou ferme rencontre *)
(* si 0 alors aucun fichier correspond *)
var NumFich : byte;
begin
  for NumFich := 1 to MX_FILE_ZN do
    if open=FileZn[NumFich].open then
      begin
        FirstFileZn := NumFich;
        exit;
      end;
  FirstFileZn := 0; (* rien trouve!! *)
end;

procedure CloseZn(NumFich : byte);
begin
  if FileZn[NumFich].open then
    begin
      FreeMem(FileZn[NumFich].adr,
              FileZn[NumFich].Zn.ht*FileZn[NumFich].Zn.lg*2);
      FileZn[NumFich].open := false;
    end;
end;

function SaveZn(Zn : Zn_Rec) : byte;
(* sauvegarde la portion d'ecran designe dans un pseudo fichier *)
var line : byte;
    NumFich : byte;
begin
  NumFich := FirstFileZn(false);
  if NumFich>0 then
    begin
      FileZn[NumFich].open := true;
      RbtZn(Zn);
      FileZn[NumFich].Zn := Zn;
      GetMem(FileZn[NumFich].Adr,Zn.Ht*Zn.Lg*2);
      for line := Zn.Y to Zn.Y+Zn.Ht-1 do
        FromScr(ptr(FileZn[NumFich].Seg,
                FileZn[NumFich].Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
                Zn.X, Line,Zn.Lg);
    end;
  SaveZn := NumFich;
end;

function SaveZc(x,y,lg,ht : byte) : byte;
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  SaveZc := SaveZn(Zn);
end;

procedure RstZn(NumFich : byte);
(* reaffiche la portion d'ecran sauve par SaveZn *)
(* le fichier n'est pas clos! *)
var Line : byte;
    Zn : Zn_Rec;
begin
  if FileZn[NumFich].open then
    begin
      Zn := FileZn[NumFich].Zn;
      for Line := Zn.Y to Zn.Y+Zn.Ht-1 do
        ToScr(ptr(FileZn[NumFich].Seg,
                  FileZn[NumFich].Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
              Zn.X,Line,Zn.Lg);
    end;
end;

procedure RstZnTo(NumFich,x,y : byte);
var Zn,cpZn : Zn_Rec;
    Line : byte;
begin
  if FileZn[NumFich].open then
    begin
      Zn := FileZn[NumFich].Zn;
      Zn.X := x;
      Zn.Y := y;
      cpZn := Zn;
      RbtZn(Zn);
      if (cpZn.X=Zn.X) and (cpZn.Y=Zn.Y) and (cpZn.Lg=Zn.Lg) and
         (cpZn.Ht=Zn.Ht) then
        for Line := Zn.Y to Zn.Y+Zn.Ht-1 do
          ToScr(ptr(FileZn[NumFich].Seg,
                    FileZn[NumFich].Ofs+(Line-Zn.Y)*(Zn.Lg*2)),
                Zn.X,Line,Zn.Lg);
    end;
end;

(****************************)
(*            WIND          *)
(****************************)

procedure DessWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
begin
  FillZn(Zn,32,ZAtt);
  CdrZn(Zn,CdrTab[style],CAtt);
end;

procedure DessWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  DessWd(Zn,ZAtt,style,CAtt);
end;

procedure PushWd( Zn : Zn_Rec; ZAtt,style,CAtt : byte);
begin
  PushZn(Zn);
  DessWd(Zn,ZAtt,style,CAtt);
end;

procedure PushWc(x,y,lg,ht : byte; ZAtt,style,CAtt : byte);
var Zn : Zn_Rec;
begin
  Zn.x := x;
  Zn.y := y;
  Zn.lg := lg;
  Zn.ht := ht;
  PushZn(Zn);
  DessWd(Zn,ZAtt,style,CAtt);
end;

procedure PopWd;
begin
  PopZn;
end;


Procedure CurOFF; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    OR   CH, 00100000b    { bit 5-6 = 01 => invisible }
    INT  INTVIDEO
End;


Procedure CurON; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    INT  INTVIDEO
End;


Procedure CurSmall; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 11           { ligne de debut }
    OR   CL, 12           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 6            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;


Procedure CurBig; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 0            { ligne de debut }
    OR   CL, 13           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 0            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;



Procedure CurPos( column, row : Byte ); Assembler;
Asm
    MOV  AH, 02h
    MOV  DL, column
    MOV  DH, row
    XOR  BH, BH
    INT  INTVIDEO
End;


Function OpenVideoSys( VMode : Byte; neige : boolean) : Byte;
var index : byte;
    Reg : Registers;
    adr : Pointer;
begin
  LastVideoMode := GetVideoMode;

  If VMode=VMODE_UNDEF Then
   Begin
    Intr($11,Reg);
    If Reg.AX And 48=48 Then VideoMode := VMODE_MDA
    Else VideoMode := VMODE_CGA;
   End
  Else
   If VMode=VMODE_MDA Then VideoMode := VMODE_MDA
   Else VideoMode := VMODE_CGA;

  If VideoMode=VMODE_MDA Then
   Begin
    SetVideoMode(MONO);
    ScrSnow := FALSE;
    adr     := Ptr($B000,$0000);
   End
  Else
   Begin
    SetVideoMode(C80);
    ScrSnow := Neige;
    adr     := Ptr($B800,$0000);
   End;

  MemScr := adr;
  ScrAdr := adr;

  While (FirstPileZn<>NIL) do PopNoZn;

  ScrLg    := 80;
  ScrHt    := 25;
  for index := 1 to MX_FILE_ZN do FileZn[index].open := false;

  OpenVideoSys := VideoMode;
end;


procedure CloseVideoSys;
var index : byte;
begin
  While (FirstPileZn<>NIL) do PopNoZn;

  for index := 1 to MX_FILE_ZN do
    if FileZn[index].open then CloseZn(index);
  SetVideoMode(LastVideoMode);
end;


Procedure KeepVideo;
Begin
 PushZc(0,0,ScrLg,ScrHt);
 SetVideoMode(LastVideoMode);
End;


Procedure ResumeVideo;
Begin
 If VideoMode=VMODE_MDA Then SetVideoMode(MONO) Else SetVideoMode(C80);
 PopZn;
End;


Begin
  FirstPileZn := NIL;
  LastPileZn  := NIL;
End.
